%2005/2/10, 2003/6/30
%bundle adjustment, from 2003 june 30
%---------- usage ----------------------------------------------
%function ba(ba_stage,klt_stage,klt_display_tag)
%ba_stage=1->7:
%   1=klt stage; 2=feature extraction KLT ; 3=epipolar filter;
%   4=lowe strutcure pose calculation, 5=diplay lowe data
%   6=augmented reality, 7=vrml generation
%klt_stage=1->3: 1=extract features;2=feat filtering ;3=feat display
%klt_display_tag=0->2: 0=no_display; 2=display step by step features
%----- examples ---------------------------------------------------
%usage: ba %from the begining, redo everything
%usage: ba(1,2,0)   %from ba_stage=1, from klt_stag=2, klt_display_tag=0:
%                   redo feature (motion-position) filter again
%usage: ba(1,2,2)   %from ba_stage=1, from klt_stag=3, klt_display_tag=2
%                   show step by step feature motion for each frame
%usage: ba(2)       %from ba_stage=2, epipolar filter, slow
%usage: ba(3)       %from ba_stage=3, feature filter by motion/location
%usage: ba(4)       %from ba_stage=4, redo structure reconstruction
%usage: ba(5)       %from ba_stage=5, display lowe result data
%usage: ba(6)       %from ba_stage=6, remake augmented reality movie
%usage: ba(7)       %from ba_stage=7, generate vrml directly
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function ba(ba_stage,klt_stage,klt_display_tag)
toolpaths=sub_add_path;
if nargin<3, klt_display_tag=0; end
if nargin<2, klt_stage=0; end
if nargin<1, ba_stage=1; end
%0 msut run 00000000000000000000000000000000000000000000000000000000
%function ba_inpar(from_stage,show_feature_mode,tname)
%
%choose one of the followings, they are tested ok
%       vvvvvvvvv the followings are tested
%in=ba_inpar(klt_stage,klt_display_tag,'flask7');     sfm_method='lowe_212';
%in=ba_inpar(klt_stage,klt_display_tag,'shake2');     sfm_method='lowe_212';
%in=ba_inpar(klt_stage,klt_display_tag,'shake4');     sfm_method='lowe_212';

%video preprocessor:
% first convert vidoe into jpg files
%function avi2img(avi_filename,out_dir,out_head,first_index,nframes,extension)    
avi_filename='d:\0vision\0test_images\video17\avi\video17.avi'
out_dir='d:\0vision\0test_images\video17\'
out_head='video17_'
first_index=1
nframes=60
extension='.bmp'

%will fix this
%avi2img(avi_filename,out_dir,out_head,first_index,nframes,extension)    


%in=ba_inpar(klt_stage,klt_display_tag,'video17');     sfm_method='lowe_212';

% in=ba_inpar(klt_stage,klt_display_tag,'flask7');     sfm_method='original_factorization';
% in=ba_inpar(klt_stage,klt_display_tag,'siu1a');      sfm_method='lowe_212';
% in=ba_inpar(klt_stage,klt_display_tag,'robot216');   sfm_method='lowe_212';
% in=ba_inpar(klt_stage,klt_display_tag,'robot216');   sfm_method='original_factorization';
%in=ba_inpar(klt_stage,klt_display_tag,'corn5');sfm_method='original_factorization';
%in=ba_inpar(klt_stage,klt_display_tag,'corn5');sfm_method='sequential_factorization';
%in=ba_inpar(klt_stage,klt_display_tag,'corn5');sfm_method='paraperspective_factorization';
%in=ba_inpar(klt_stage,klt_display_tag,'head11a');sfm_method='lowe_212';
%in=ba_inpar(klt_stage,klt_display_tag,'head11b');sfm_method='lowe_212';

% in=ba_inpar(klt_stage,klt_display_tag,'boxe3');      sfm_method='lowe_212';
%in=ba_inpar(klt_stage,klt_display_tag,'cam101');      sfm_method='lowe_212';
%in=ba_inpar(klt_stage,klt_display_tag,'cam201');      sfm_method='lowe_212';
%in=ba_inpar(klt_stage,klt_display_tag,'cam113_1_sing'); sfm_method='original_factorization';
%in=ba_inpar(klt_stage,klt_display_tag,'cam113_2_sing'); sfm_method='original_factorization';

%in=ba_inpar(klt_stage,klt_display_tag,'boxe3');      sfm_method='original_factorization';
%in=ba_inpar(klt_stage,klt_display_tag,'boxe3');      sfm_method='sequential_factorization';
%in=ba_inpar(klt_stage,klt_display_tag,'boxe3');      sfm_method='paraperspective_factorization';

%in=ba_inpar(klt_stage,klt_display_tag,'cam113_2');      sfm_method='lowe_212';
% in=ba_inpar(klt_stage,klt_display_tag,'lab524');     sfm_method='lowe_202';
% in=ba_inpar(klt_stage,klt_display_tag,'cany525');    sfm_method='lowe_202';
% in=ba_inpar(klt_stage,klt_display_tag,'canyon1');    sfm_method='lowe_212';
% in=ba_inpar(klt_stage,klt_display_tag,'piantist');   sfm_method='lowe_212';
% in=ba_inpar(klt_stage,klt_display_tag,'arcaba');     sfm_method='lowe_101';
 in=ba_inpar(klt_stage,klt_display_tag,'house01');    sfm_method='lowe_212';
% in=ba_inpar(klt_stage,klt_display_tag,'robot3');     sfm_method='lowe_212';
% in=ba_inpar(klt_stage,klt_display_tag,'robot2');     sfm_method='lowe_212';
% in=ba_inpar(klt_stage,klt_display_tag,'labe7');      sfm_method='lowe_212';
% in=ba_inpar(klt_stage,klt_display_tag,'labe1');      sfm_method='lowe_202';

%VVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVV
[cam,wdir,feature,in]=ba_init(in);
save('ba_inpar') ; %input parameters, all in structure in.

%------------------------------------------------------------------
%1 feature tracking 1111111111111111111111111111111111111111111111
ixy_filename='klt_data';
if ba_stage<=1
    cv_klt(ixy_filename,cam,wdir,feature,in); %ouput to ixy_filename
end

%------------------------------------------------------------------
% Fseq calculation 22222222222222222222222222222
% epipolar based filter use F to filter features1
%by ransac

% 222222222222222222222222222222222222222222222222222222222222222222222
in.ep_filter_tag=0;
if in.ep_filter_tag  ==1
    if ba_stage<=2
        Fseq=computeF2_main;
        size(Fseq)
    end

    %------------------------------------------------------------------
    %3  epipolar filtering 33333333333333333333333333333333333333333333
    if ba_stage<=3
        ixy_method='ep_filter_data_from_klt' %faster
        %ixy_method='ep_filter_data_from_corr' %slower
        switch ixy_method
            case 'ep_filter_data_from_klt'
                ep_filter_from_klt
                ixy_filename='ep_filter_data_from_klt';
                %from correlation of windows from ep F
            case 'ep_filter_data_from_corr'
                ep_filter_from_corr
                ixy_filename='ep_filter_data_from_corr';
        end
    end
    %test ---- display x_seg xp_seq-------------------------
else
    ixy_filename='klt_data';
end

%------------------------------------------------------------------
% structure reconstruction 44444444444444444444444444444444444444
if ba_stage<=4
    %------------method 1 (older but ok )-------------------
    %initmodel('ep_filter_data','tempo_lowe212',1)

    %-----------method 2 (new ok )----------------

    switch sfm_method %cv_lowexxx(iter, infile, outfile, syn_model,display_tag))
        case 'lowe_202',
            cv_lowe202(30,ixy_filename,'lowe2xx_out',0,0); %2-pass without filter, suitbale for planar surface dominated images
            model_output_fname='lowe2xx_out';
        case 'lowe_212',
            %cv_lowe212(30,ixy_filename,'lowe2xx_out',0,0); %2-pass with filter, food for normal files, 2pass no good for planar images
            %model_output_fname='lowe2xx_out';


            load(ixy_filename,'flen','ix','iy','zinit');
%%-------- adhoc test
% [foo,nframes]=size(ix)
% ix=ix(:,1:5:nframes)
% iy=iy(:,1:5:nframes)
% [foo,nframes]=size(ix)

%-----------------------
            [model,rt,er,et,ix,iy,m,syn_model,syn_trans_angles]=...
                cv_lowe212b(30,flen,ix,iy,zinit,0,0)
            model_output_fname='lowe2xx_out';
            save('lowe2xx_out','m','ix','iy','flen','model','rt','er','et','syn_model','syn_trans_angles','zinit');

        case 'lowe_101',
            cv_lowe101(30,ixy_filename,'lowe2xx_out',0,0);% full bundle adjustment suitbale for planar surface dominated images
            model_output_fname='lowe2xx_out';



        case 'original_factorization'
            [P,RT_sol,error_trucco_all_time,mse_error_model_pixels2_loop]=...
                cv_factorization(ixy_filename,sfm_method);% full bundle adjustment suitbale for planar surface dominated images
            model_output_fname='factorization_out';
        case 'sequential_factorization'
            [P,RT_sol,error_trucco_all_time,mse_error_model_pixels2_loop]=...
                cv_factorization(ixy_filename,sfm_method);% full bundle adjustment suitbale for planar surface dominated images
            model_output_fname='factorization_out';
        case 'paraperspective_factorization'
            [P,RT_sol,error_trucco_all_time,mse_error_model_pixels2_loop]=...
                cv_factorization(ixy_filename,sfm_method);% full bundle adjustment suitbale for planar surface dominated images
            model_output_fname='factorization_out';
        otherwise
            'ERROR: ba.m error: sfm_method not defined'
            pause
    end

    in.mismatch_filter_tag=0 %overwrite that in ba_inpar.m
    if in.mismatch_filter_tag==1
        cv_lowe_filter('lowe2xx_out','lowe2xx_out');   %filter noise
        cv_lowe202(20,'lowe2xx_out','lowe2xx_out');
    end
    %
end
% display lowe output data 55555555555555555555555555555555555555555555555555555
display_ba_stage_5=1
if ba_stage<=5 & display_ba_stage_5==1
    load('lowe2xx_out');
    show_rt(rt,model)
end

% augmented reality   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
ba_stage6_tag=0
if ba_stage<=6 & ba_stage6_tag==1
    load('lowe2xx_out'); %work for boxe3 only
    init_center=[0 0 zinit];
    augmented_reality3(model,init_center,ix,iy,rt);
end
%------------------------------------------------------------------

%------------------------------------------------------------------
% vrml genaration 666666666666666666666666666666666666666666666666
if ba_stage<=7
    %--------------- gene vrml ----------------------------------
    %ba_gen_vrml_one('ba_inpar','lowe2xx_out',vrml_display_tag); %circular algo and general vrml
    %ba_gen_vrml_one('ba_inpar','lowe2xx_out',0); %circular algo and general vrml
    toggle_inside_out=0, toggle_external_internal_texture=0; %1 is active 0 is not %factorization, the output cannot be predicted
    ba_gen_vrml_one('ba_inpar',model_output_fname,0,toggle_inside_out,toggle_external_internal_texture); %circular algo and general vrml
end
sub_remove_path(toolpaths);




%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                                                                   %
%                                                                   %
%                                                                   %
%              Functions                                            %
%                                                                   %
%                                                                   %
%                                                                   %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function toolpaths=sub_add_path
current_dir=pwd;
toolpaths{1}=strcat(current_dir,'\cv_toolbox1');
toolpaths{2}=strcat(current_dir,'\ep_toolbox');
toolpaths{3}=strcat(current_dir,'\ar_toolbox');
nn=length(toolpaths);
for n=1:nn
    path(path,toolpaths{n})
end
return

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function sub_remove_path(toolpaths)
nn=length(toolpaths);
for n=1:nn
    rmpath(toolpaths{n})
end
return
