%system init1, return (struct)s: sys,cam,widr,feature
%init1(100,9,1)
%n_models is used for multiple model building only, 
%if single model is used, use n_models=1 and index_model =1
function [cam,wdir,feature,in]=ba_init(in)

%--------------------------------------------------------------------------

%sys=sub_init_sys_parameters; % 11111111
wdir=sub_init_work_directories(in); %  222222222222
cam=sub_init_cam_parameters(in,wdir);		% 33333333333333
feature=sub_init_feature_parameters(in,cam); %4444444444
in=sub_init_operation_parameters(in,cam,wdir); %55555555555555

disp(sprintf('---------------------------  init done --------------------------------------'));

%RRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRR


%######################################################
%
%   sub functions
%
%
%#########################################################

%22222222222222222222222222222222222222222222222222222222222222
%--------- directory handling ---------------------------------
function wdir=sub_init_work_directories(in)
ss=pwd;  %find drive of your system 
wdir.drive=ss(1:2);
%wdir.drive='c:'; %can change to other drives, fixed drive method

wdir.file_head=strcat(in.tname,'_');
wdir.temp=strcat(wdir.drive,'\0vision\0test_images\0temp\');
wdir.test_dir_name=strcat(wdir.drive,'\0vision\0test_images\',in.tname,'\');
wdir.test_name=in.tname;

%for c based klt tracker, see ct_extract_raw_features2.m
wdir.input_pgm_dir=strcat(wdir.drive,'\0vision\0test_images\0temp\temp_pgm\');
wdir.temp_pgm=strcat(wdir.drive,'\0vision\0test_images\0temp\temp_pgm\');
%----------------------------------------------------------------------
switch in.workmode
    case {'augm'},
        workx=strcat(wdir.drive,'\0vision\0test_images\',in.tname,'\0work_augm');
        vrmlx=strcat(wdir.drive,'\0vision\0test_images\',in.tname,'\0vrml_augm');
        featx=strcat(wdir.drive,'\0vision\0test_images\',in.tname,'\0feat_augm');
    case {'comb'},
        workx=strcat(wdir.drive,'\0vision\0test_images\',in.tname,'\0work_comb');
        vrmlx=strcat(wdir.drive,'\0vision\0test_images\',in.tname,'\0vrml_comb');
        featx=strcat(wdir.drive,'\0vision\0test_images\',in.tname,'\0feat_comb');
    case 'single' %single model
        workx=strcat(wdir.drive,'\0vision\0test_images\',in.tname,'\0work_sing');
        vrmlx=strcat(wdir.drive,'\0vision\0test_images\',in.tname,'\0vrml_sing');
        featx=strcat(wdir.drive,'\0vision\0test_images\',in.tname,'\0feat_sing');
    case 'lowe' %single model
        workx=strcat(wdir.drive,'\0vision\0test_images\',in.tname,'\0work_lowe');
        vrmlx=strcat(wdir.drive,'\0vision\0test_images\',in.tname,'\0vrml_lowe');
        featx=strcat(wdir.drive,'\0vision\0test_images\',in.tname,'\0feat_lowe');
    otherwise 
        disp('unknown workmode');
end
command_mkdir=sprintf('mkdir %s',workx)%donnot allow \ for make dir. will add \ later
dos(command_mkdir)

command_mkdir=sprintf('mkdir %s',vrmlx)%donnot allow \ for make dir. will add \ later
dos(command_mkdir)

command_mkdir=sprintf('mkdir %s',featx)%donnot allow \ for make dir. will add \ later
dos(command_mkdir)

wdir.work=strcat(workx,'\'); %add \ to become full pasth,
wdir.vrml=strcat(vrmlx,'\');
wdir.output_features_dir=strcat(featx,'\');
return
%eeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeee

%33333333333333333333333333333333333333333333333333333333333333
function cam=sub_init_cam_parameters(in,wdir)
% define sys1 structure --------------
%cam.flen=848;

fn0=strcat(wdir.drive,'\0vision\0test_images\',in.tname,'\',in.tname,'_000',in.extension);
im=imread(fn0);
[myy,mxx,foo]=size(im);

cam.focal_length_in_meters= 0.0046;

cam.screen_max_x=mxx;
cam.screen_max_y=myy;
cam.ixcenter=round(mxx/2);
cam.iycenter=round(myy/2);

cam.pixel_width_meters=in.pixel_width_meters; %=5.42*10^-6;
cam.flen=cam.focal_length_in_meters/cam.pixel_width_meters; %5.42um
return
%-return----------  get camera parameters  ---------------
%eeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeee


%44444444444444444444444444444444444444444444444444444444444444444444444

function feature=sub_init_feature_parameters(in,cam)

feature.feature_will_come_code = -9010;
feature.feature_lost_code = -9020;
feature.feature_unused_code = -9110;

%now only 
%feature.raw_ix, iy iv, obtained from klt.c
%feature.rpy_ix, iy iv for rpy corrridnts system, main working data
%feature.scr_ix,iy,iv are used, for display only, 

%----------------------------feature usage----------------------------
%rpy_ix, rpy_iy are features for tracking (they have been filterd:motion, position)
%scr_ix,scr_iy are for display, 
%raw_ix,raw_iy are raw fron the tracker, not much use for tracking
% feature_x or features y of size n_features max_t have the following values
%-- each row contains only one feature, see xxx_ival, xxx can be rpy_, scr_, raw_
%-- values in xxx_ival
% case a) a value >0, means a new feature is found , x y positions  
%         are in xxx_x, xxx_y.
% case b) -9010=will come code, a feature will appear in that row but not yet
% case c) -9020=lost code, a feature being tracked has been lost

return
%EEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEE	




%5555555555555555555555555555555555555555555555555555555555555555555
function in=sub_init_operation_parameters(in,cam,wdir)

in.n_features_per_frame=in.n_features; %300 is ideal for combinend boxe1 model 
in.n_model_line_x=50;  %adjust it form 3d display 3d accuarcy, 50 is fast but crude, 500 is finer
in.init_center=[0, 0, (in.z_init_meters/cam.pixel_width_meters)];
in.texture_fname_head=strcat('\0vision\0test_images\',in.tname,'\',in.tname,'_')
return
%EEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEE		
