%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function ba(ba_stage,klt_stage,klt_display_tag)
toolpaths=sub_add_path;
if nargin<3, klt_display_tag=0; end
if nargin<2, klt_stage=0; end
if nargin<1, ba_stage=1; end

in.tname='corn5';
        in.extension='.bmp';
        
        in.workmode='lowe';
        in.klt_replace_tag=0;
        in.total_frames_in_sequence=29; %number of avaible frame in the sequence.
        in.n_sector_frames=10; %100 %239-10-1; %73
        in.Tinit=in.n_sector_frames-1;
        in.base_frame_index=1;; %[ 1 1 1 1] %dummy for gc_gen_vrml (even for one sector)
        in.n_features=300; %500
        in.markersize_features=3;
        in.z_init_meters=0.33;
        in.pixel_width_meters=5.42*10^-6;
        in.klt_check_xy_limit_tag=1;in.features_xy_limits=[100 500 100 420]; %[xmin xmax, ymin ymax]
        in.klt_feature_motion_tag=1;in.features_motion_limits=[0.5 100 0.5 100]; 
        in.mismatch_filter_tag=1;
        in.threshold_epip_error=0.3; %in pixels
%        in.nF_step=1;
        
        in.vrml.extension=in.extension
        in.vrml.write_mode= 'one' ;%'omni' : all angles (combined by 4), 'independent'= 4 different views ,'one'
        in.vrml.external_internal_texture_mode=0; %1 or 0 %0 for lowe
        in.vrml.inside_out_transform=0; %0 for lowe, 0 for cir, 
        
%VVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVV
[cam,wdir,feature,in]=ba_init(in);
save('ba_inpar') ; %input parameters, all in structure in.
%------------------------------------------------------------------
%1 feature tracking 1111111111111111111111111111111111111111111111
ixy_filename='klt_data';

if ba_stage<=1
    cv_klt(ixy_filename,cam,wdir,feature,in); %ouput to ixy_filename
end
if ba_stage<=4
    %------------method 1 (older but ok )-------------------
    %initmodel('ep_filter_data','tempo_lowe212',1)

    %-----------method 2 (new ok )----------------

    switch sfm_method %cv_lowexxx(iter, infile, outfile, syn_model,display_tag))
        case 'lowe_202',
            cv_lowe202(30,ixy_filename,'lowe2xx_out',0,0); %2-pass without filter, suitbale for planar surface dominated images
            model_output_fname='lowe2xx_out';
        case 'lowe_212',
            load(ixy_filename,'flen','ix','iy','zinit');
            [model,rt,er,et,ix,iy,m,syn_model,syn_trans_angles]=...
             cv_lowe212b(30,flen,ix,iy,zinit,0,0)
            model_output_fname='lowe2xx_out';
            save('lowe2xx_out','m','ix','iy','flen','model','rt','er','et','syn_model','syn_trans_angles','zinit');
        
        case 'lowe_101',
            cv_lowe101(30,ixy_filename,'lowe2xx_out',0,0);% full bundle adjustment suitbale for planar surface dominated images
            model_output_fname='lowe2xx_out';
            
        case 'original_factorization'
            [P,RT_sol,error_trucco_all_time,mse_error_model_pixels2_loop]=...
                cv_factorization(ixy_filename,sfm_method);% full bundle adjustment suitbale for planar surface dominated images
            model_output_fname='factorization_out';
        case 'sequential_factorization'
            [P,RT_sol,error_trucco_all_time,mse_error_model_pixels2_loop]=...
                cv_factorization(ixy_filename,sfm_method);% full bundle adjustment suitbale for planar surface dominated images
            model_output_fname='factorization_out';
        case 'paraperspective_factorization'
            [P,RT_sol,error_trucco_all_time,mse_error_model_pixels2_loop]=...
                cv_factorization(ixy_filename,sfm_method);% full bundle adjustment suitbale for planar surface dominated images
            model_output_fname='factorization_out';
        otherwise
            'ERROR: ba.m error: sfm_method not defined'
            pause
    end
    
    if ba_stage<=7
    %--------------- gene vrml ----------------------------------
    %ba_gen_vrml_one('ba_inpar','lowe2xx_out',vrml_display_tag); %circular algo and general vrml
    %ba_gen_vrml_one('ba_inpar','lowe2xx_out',0); %circular algo and general vrml
    toggle_inside_out=0, toggle_external_internal_texture=0; %1 is active 0 is not %factorization, the output cannot be predicted
        ba_gen_vrml_one('ba_inpar',model_output_fname,0,toggle_inside_out,toggle_external_internal_texture); %circular algo and general vrml
end
sub_remove_path(toolpaths);