%2005/2/10, 2003/6/30
%bundle adjustment, from 2003 june 30
%---------- usage ----------------------------------------------
%function ba(ba_stage,klt_stage,klt_display_tag)
%ba_stage=1->7: 
%   1=klt stage; 2=feature extraction KLT ; 3=epipolar filter;
%   4=lowe strutcure pose calculation, 5=diplay lowe data
%   6=augmented reality, 7=vrml generation
%klt_stage=1->3: 1=extract features;2=feat filtering ;3=feat display
%klt_display_tag=0->2: 0=no_display; 2=display step by step features
%----- examples ---------------------------------------------------
%usage: ba %from the begining, redo everything
%usage: ba(1,2,0)   %from ba_stage=1, from klt_stag=2, klt_display_tag=0:
%                   redo feature (motion-position) filter again
%usage: ba(1,2,2)   %from ba_stage=1, from klt_stag=3, klt_display_tag=2
%                   show step by step feature motion for each frame
%usage: ba(2)       %from ba_stage=2, epipolar filter, slow 
%usage: ba(3)       %from ba_stage=3, feature filter by motion/location
%usage: ba(4)       %from ba_stage=4, redo structure reconstruction
%usage: ba(5)       %from ba_stage=5, display lowe result data
%usage: ba(6)       %from ba_stage=6, remake augmented reality movie
%usage: ba(7)       %from ba_stage=7, generate vrml directly
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function ba(ba_stage,klt_stage,klt_display_tag)
toolpaths=sub_add_path;
if nargin<3, klt_display_tag=0; end
if nargin<2, klt_stage=0; end
if nargin<1, ba_stage=1; end
%0 msut run 00000000000000000000000000000000000000000000000000000000
%function ba_inpar(from_stage,show_feature_mode,tname)
%
%choose one of the followings, they are tested ok
%       vvvvvvvvv the followings are tested 

% % cam 1 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if ba_stage<=1
    in=ba_inpar(klt_stage,klt_display_tag,'head11a');      sfm_method='lowe_212';
    %VVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVV
    [cam,wdir,feature,in]=ba_init(in);
    save('ba_inpar') ; %input parameters, all in structure in.
    %------------------------------------------------------------------
    %1 feature tracking 1111111111111111111111111111111111111111111111
    ixy_filename='klt_data';
    %if ba_stage<=1
    cv_klt(ixy_filename,cam,wdir,feature,in); %ouput to ixy_filename
    %end
    %save ata for multi cameras
    load (ixy_filename)
    xycell{1,1}=ix;
    xycell{1,2}=iy;
    
    % cam2 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    in=ba_inpar(klt_stage,klt_display_tag,'head11b');      sfm_method='lowe_212';
    %VVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVV
    [cam,wdir,feature,in]=ba_init(in);
    save('ba_inpar') ; %input parameters, all in structure in.
    %------------------------------------------------------------------
    %1 feature tracking 1111111111111111111111111111111111111111111111
    ixy_filename='klt_data';
    %if ba_stage<=1
    cv_klt(ixy_filename,cam,wdir,feature,in); %ouput to ixy_filename
    %end
    load (ixy_filename)
    xycell{2,1}=ix;
    xycell{2,2}=iy;
    
    RK(:,:,1)=eye(3);
    RK(:,:,2)=[0 0 1; 0 1 0 ; -1 0 0];
    save('real_dat','xycell','RK');
    'data saved in real_dat.mat'
end
'press any key to continue'
pause

sub_remove_path(toolpaths);
%222222222222222222222222222222222222222222222222222222222222222222222
%save data for multi cameras
if ba_stage<=2
    % 'press key to execute lowe321; control-C to quit'
    % pause
    lowe321c(1)
    lowe321c(2)
    show_lowe321_rb
end










%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                                                                   %
%                                                                   %
%                                                                   %
%              Functions                                            %
%                                                                   %
%                                                                   %
%                                                                   %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function toolpaths=sub_add_path
current_dir=pwd;
toolpaths{1}=strcat(current_dir,'\cv_toolbox1');
toolpaths{2}=strcat(current_dir,'\ep_toolbox');
toolpaths{3}=strcat(current_dir,'\ar_toolbox');
nn=length(toolpaths);
for n=1:nn
    path(path,toolpaths{n})
end
return

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function sub_remove_path(toolpaths)
nn=length(toolpaths);
for n=1:nn
    rmpath(toolpaths{n})
end
return
