%lowe: extended lowe reconstruction
function [model,rt,ix,iy,error2_2d,error2_time]=initmodel(flen,ix,iy,zinit,niter,outfile)
%(flen,ix,iy,zinit,'temp',20)
%infile is the ix,iy file with NaN 
    
%if nargin<2, outfile='tempo'; end
%if nargin<1, infile='syn_dat'; end
if nargin<6, outfile='tempo'; end

%%%%%%%%%%%%load(infile);

%load ba_inpar;
[foo,temp1]=size(ix);
%Tinit=in.Tinit-2; %quick fix, should look again %%%%%%%%%%%%%%%%%%
Tinit=temp1-2; %quick fix, should look again %%%%%%%%%%%%%%%%%%

if ~exist('flen')    %   if flen does not exist
    flen=848;         %    flen=848
end
if ~exist('zinit')      %if zinit does not exist, put in default value
    zinit=60836;
end

[N,T]=size(ix);

%phase 1 iteration, build up rt gradually

% rt=zeros(3,4,T);
% rt(:,:,1)=[eye(3) [0;0;zinit]];
% rt(:,:,2)=rt(:,:,1);

%init model
%Tinit=19;               %frames use to init model
[model,rt] = init_model(ix,iy,flen,zinit,Tinit,niter);

for t=Tinit+1:T   
    rt(:,:,t)=rt(:,:,t-1);      %init for the for loop
    err=project_err(flen,model,ix(:,1:t),iy(:,1:t),rt(:,:,1:t)); %??????
    mserror(err)
    
    v=find(~isnan(ix(:,t)));   %find valid points
    s=find(model(4,:)==0);      %find all uninitialized points
    v = setdiff(v,s);           %exclude all uninitialized points
    err=column_err(flen, model(:,v), ix(v,t), iy(v,t), rt(:,:,t));
    J = JacobRT(flen, model(:,v), rt(:,:,t));     %pass only valid points 
    delta = J\err;		%delta=3T+3T
    dT = delta(1:3);
    dR = delta(4:6);
    rt(1:3,4,t) = rt(1:3,4,t)+dT;       %estimate pose for new frame
    rt(1:3,1:3,t) = rpyMat(dR)*rt(1:3,1:3,t);
    
    %update model
    err=project_err(flen,model,ix(:,1:t),iy(:,1:t),rt(:,:,1:t));         
    mserror(err)
    
    N=size(model,2);                    %N may change because points in model are deleted
    for i=N:-1:1
        if (model(4,i)~=0)
            v = find(~isnan(ix(i,1:t))); %pick up all good frames for point i
            if length(v) >=5        %if point has at least 2 frames, update model
                err=row_err(flen, model(:,i), ix(i,v), iy(i,v), rt(:,:,v));
                J = JacobM(flen, model(:,i), rt(:,:,v));
                if cond(J) > 100
                    model(:,i)=[];    %delete
                    ix(i,:)=[];
                    iy(i,:)=[];
                else
                    delta = J\err;      %if cond is ok, update model
                    model(1:3,i) = model(1:3,i) + delta;
                end
            end
        end
    end
    
    err=project_err(flen,model,ix(:,1:t),iy(:,1:t),rt(:,:,1:t));         
    mserror(err)
    
    %init model points that start at frame t
    model = init_next_frame(model,rt,ix,iy,flen,zinit,t);
end

model=model(1:3,:);     %remove 4th row
save(outfile, 'model', 'ix', 'iy', 'flen', 'rt', 'zinit');


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%              fucntions                                 %%%%%%%%%%
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function e = mserror(v)  %calc the mean square error
e = sqrt(sum(v.^2)/length(v));

function [model,rt] = init_model(ix,iy,flen,zinit,Tinit,Niter)
[N,T]=size(ix);
rt=zeros(3,4,T);
rt(:,:,1)=[eye(3) [0;0;zinit]];
v=[];               %v contains the set of points for init model
for i=1:N           %screen those points in ix,iy that can be used to init model
    w = find(~isnan(ix(i,1:Tinit)));
    if length(w>=5) & ~isnan(ix(i,1))
        v=[v i];    %add i to set w
    end
end
model(:,v) = [(zinit/flen)*ix(v,1)'; (zinit/flen)*iy(v,1)'; zeros(size(v)); ones(size(v))];

for iter=1:Niter
    iter
    for j=2:Tinit                       %compute rt for frame 1:Tinit
        v1 = find(~isnan(ix(:,j)));
        w = intersect(v,v1);            %get the common points in frame 1 and frame i
        if iter==1
            err=column_err(flen, model(:,w), ix(w,j), iy(w,j), rt(:,:,j-1));
            J = JacobRT(flen, model(:,w), rt(:,:,j-1));     %pass only valid points 
            delta = J\err;		%delta=3T+3T
            dT = delta(1:3);
            dR = delta(4:6);
            rt(1:3,4,j) = rt(1:3,4,j-1)+dT;
            rt(1:3,1:3,j) = rpyMat(dR)*rt(1:3,1:3,j-1);
        else
            err=column_err(flen, model(:,w), ix(w,j), iy(w,j), rt(:,:,j));
            J = JacobRT(flen, model(:,w), rt(:,:,j));     %pass only valid points 
            delta = J\err;		%delta=3T+3T
            dT = delta(1:3);
            dR = delta(4:6);
            rt(1:3,4,j) = rt(1:3,4,j)+dT;
            rt(1:3,1:3,j) = rpyMat(dR)*rt(1:3,1:3,j);
        end
    end
    for i=1:length(v)                           %update model using Tinit views
        w = find(~isnan(ix(v(i),1:Tinit)));  %pick up all good frames for point i
        err=row_err(flen, model(:,v(i)), ix(v(i),w), iy(v(i),w), rt(:,:,w));
        J = JacobM(flen, model(:,v(i)), rt(:,:,w));
        delta = J\err;
        model(1:3,v(i)) = model(1:3,v(i)) + delta;
    end
end

function model = init_next_frame(model,rt,ix,iy,flen,z,t)
%find new points from start frame
if t==1
    v = find(~isnan(ix(:,1)));
    model(:,v) = [(z/flen)*ix(v,1)'; (z/flen)*iy(v,1)'; zeros(1,length(v)); ones(1,length(v))];
else
    v = find(~isnan(ix(:,t)));     %ix(:,t)=N*1
    s = find(model(4,:)==0);        %model(4,:)=1*N, find uninitialized points
    v = intersect(v,s);             %find new points
    if length(v)>=1
        for i = 1:length(v)
            n = v(i);
            A(1,1)=rt(1,1,t)-rt(3,1,t)*(ix(n,t)/flen);
            A(1,2)=rt(1,2,t)-rt(3,2,t)*(ix(n,t)/flen);
            A(2,1)=rt(2,1,t)-rt(3,1,t)*(iy(n,t)/flen);
            A(2,2)=rt(2,2,t)-rt(3,2,t)*(iy(n,t)/flen);
            b(1,1)=(ix(n,t)/flen)*rt(3,4,t) - rt(1,4,t);
            b(2,1)=(iy(n,t)/flen)*rt(3,4,t) - rt(2,4,t);
            model(1:2,n)=A\b;
            model(3,n)=0;
            model(4,n)=1;
        end
    end
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [ix, iy] = filter_short_run(ix,iy)
[N,T] = size(ix);
for n=N:-1:1       %reverse processing to delete rows     
    v = find(~isnan(ix(n,:)));
    if length(v)<4  %if row length is too short
        ix(n,:)=[];
        iy(n,:)=[];
    end
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function err=column_err(flen,model,ix,iy,rt)
%return err, a column vector of max size 3*N*T
[N,T]=size(ix);
if T~=1
    error('column_err: ix, iy must be a column vector');
end
X = rt*model;
x = flen.*X(1,:)./X(3,:);
y = flen.*X(2,:)./X(3,:);
ex = ix - x';
ey = iy - y';
err = [ex; ey];

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function err=row_err(flen,model,ix,iy,rt)
%return err, a column vector of max size 3*N*T
[N,T]=size(ix);
if N~=1
    error('row_err: ix, iy must be a row vector');
end
err=zeros(2*T,1);
for t=1:T
    X = rt(:,:,t)*model;
    x = flen.*X(1,:)./X(3,:);
    y = flen.*X(2,:)./X(3,:);
    err(t) = (ix(1,t) - x)';
    err(T+t) = (iy(1,t) - y)';
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function err=project_err(flen,model,ix,iy,rt)
%return err, a column vector of max size 3*N*T
[N,T]=size(ix);
err=[];
for t=1:T
    v = find(~isnan(ix(:,t)));         %find valid points that is not the start point
    s = find(model(4,:)==0);        %find uninitialised points
    v = setdiff(v,s);               %eliminate uninit points

   %something wrong here, pelase check ????????????????////
    column_err(flen,model(:,v),ix(v,t),iy(v,t),rt(:,:,t));
    
    err = [err; column_err(flen,model(:,v),ix(v,t),iy(v,t),rt(:,:,t))];
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function J=JacobM(flen, model, rt)
N = size(model,2);    %model=3,N
if N~=1
    error('JacobM: model size must be 4*1');
end
T = size(rt,3);       %rt=3,4,T
J=zeros(2*T,3);

for t=1:T             %index T vertical blocks
    V = rt(:,:,t)*model;
    X = V(1,:);
    Y = V(2,:);
    Z = V(3,:);
    Z2 = Z.*Z;
    XZ2 = X./Z2;
    YZ2 = Y./Z2;
    a11 = rt(1,1,t)./Z - rt(3,1,t).*XZ2;
    a12 = rt(1,2,t)./Z - rt(3,2,t).*XZ2;
    a13 = rt(1,3,t)./Z - rt(3,3,t).*XZ2;
    a21 = rt(2,1,t)./Z - rt(3,1,t).*YZ2;
    a22 = rt(2,2,t)./Z - rt(3,2,t).*YZ2;
    a23 = rt(2,3,t)./Z - rt(3,3,t).*YZ2;
    a1 = [a11' a12' a13'];
    a2 = [a21' a22' a23'];
    
    J(t,:) = a1;
    J(T+t,:) = a2;
end
J = flen.*J;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%extended lowe
function J=JacobRT(flen, model, rt)
%find RT with the R in frame 1 included
T = size(rt,3);       %rt=3,4,T
if (T~=1)
    error('rt size must be 3*4*1 only (T must equal to 1');
end
N = size(model,2);    
J=zeros(2*N,6);	 

%1:3T columns for translation
X = rt*model;		%X=RM+T
XR = rt(1:3,1:3)*model(1:3,:); %XR=RM
Z2 = X(3,:).*X(3,:);

%translation part
x1 = 1./X(3,:);
x2 = zeros(1,N);
x3 = -X(1,:)./Z2;
y1 = x2;
y2 = x1;
y3 = -X(2,:)./Z2;
J(:,1:3) = [x1' x2' x3'; y1' y2' y3'];

%rotation part
x1 = -X(1,:).*XR(2,:)./Z2;       %dxdalpha
x2 = (X(1,:).*XR(1,:)+X(3,:).*XR(3,:))./Z2;
x3 = -XR(2,:)./X(3,:);
y1 = -(X(2,:).*XR(2,:)+X(3,:).*XR(3,:))./Z2;
y2 = (XR(1,:).*X(2,:))./Z2;
y3 = XR(1,:)./X(3,:);
J(:,4:6) = [x1' x2' x3'; y1' y2' y3'];

J = flen.*J;


% Author: Rodrigo Carceroni
% Disclaimer: This code comes with no guarantee at all and its author
%   is not liable for any damage that its utilization may cause.

function R = rpyMat (angs)

% Return the 3x3 rotation matrix described by a set of Roll, Pitch and Yaw
% angles.

cosA = cos (angs(3));
sinA = sin (angs(3));
cosB = cos (angs(2));
sinB = sin (angs(2));
cosC = cos (angs(1));
sinC = sin (angs(1));

cosAsinB = cosA .* sinB;
sinAsinB = sinA .* sinB;

R = [ cosA.*cosB  cosAsinB.*sinC-sinA.*cosC  cosAsinB.*cosC+sinA.*sinC ;
    sinA.*cosB  sinAsinB.*sinC+cosA.*cosC  sinAsinB.*cosC-cosA.*sinC ;
    -sinB            cosB.*sinC                 cosB.*cosC         ];

function err=err_sphere(model)
model=model(1:3,:); %to make sure dimension of model is right
cg=mean(model,2);
N = size(model,2);
cgmat = repmat(cg, 1, N);
d = model - cgmat;
rad = sqrt( sum(d.^2) );
mean(rad);
err = std(rad)/mean(rad);
