%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%function
function cv_gen_vrml_one_v1(p1,u1,v1,vrml_texture_fname_head,vrml_extension,vrml_seg_index,vrml_inside_out_transform,...
    vrml_write_mode,vrml_external_internal_texture_mode,vrml_zinit,vrml_display_tag)

if vrml_display_tag >=1
    figure(701)
    clf
    plot3(p1(1,:),p1(2,:),p1(3,:),'g.');
    rotate3d on
    xlabel('axis-x');
    ylabel('axis-y');
    zlabel('axis-z');
    title('VRML orginal p1');
end

vtm_center=mean([p1],2);
vtm_center

if vrml_display_tag >=1
    figure(702)
    clf
    plot3(vtm_center(1),vtm_center(2),vtm_center(3),'r+');
    xlabel('x-axis');
    ylabel('y-axis');
    zlabel('z-axis');
    hold on
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
size(p1)

%%%%% importnat fix ====================================
%inside_out_transform=0;
if vrml_inside_out_transform ==1
    z_org=2* vtm_center(3); %make the model inside out to fit my corrdinate system
    
    %fix coirrd system
    p1(3,:)=z_org-p1(3,:);
end

size(u1)
'before'
%new_vtm_center=mean([p1,p2,p3,p4],2);
new_vtm_center=mean([p1],2);

u1=u1';
v1=v1';
size(p1);

size(u1)
'after',
%'test1',pause

switch vrml_write_mode
    case 'one' %--case 'omni' all angles (comnined by 4) --------------------------------------------------------
        
        output_vrml_fname=strcat('0_01vrml','.wrl');
        [fid_out_shape,errmsg] = fopen(output_vrml_fname,'w');
        if fid_out_shape == -1
            disp(' ');
            disp(['VRMLplot error - unable to open ' outfile ' for writing.']);
            clear out_shape_file;
            return;
        end
        
        sub_write_vrml_header(fid_out_shape);
        
        structure_index=1;
        %         sub_gen_cir_vrml(...
        %             vrml_zinit,vtm_center,structure_index,output_vrml_fname,fid_out_shape,...
        %             u1, v1, p1,vrml_seg_index,vrml_texture_fname_head,vrml_extension)
        %         
        sub_gen_vrml_one(vtm_center,structure_index,output_vrml_fname,fid_out_shape,...
            p1,u1,v1,vrml_texture_fname_head,vrml_extension,vrml_seg_index,vrml_inside_out_transform,...
            vrml_write_mode,vrml_external_internal_texture_mode,vrml_zinit,vrml_display_tag);
        
        
        
        %        sub_gen_cir_vrml(...
        %           vrml_zinit,vtm_center,structure_index,output_vrml_fname,fid_out_shape,...
        %          vrml,u1, v1, p1)
        
        sub_write_vrml_tailer(fid_out_shape);
        
        fclose(fid_out_shape);
        disp('0_01vrml.wrl saved');
    otherwise,
        'bad vrml_write_mode, in gc.m',pause
end


disp('--- generate vrml generated -------')
return



%FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF 
%--------------------------------------------------
%function sub_gen_cir_vrml(vrml_zinit,vtm_center,structure_index,output_vrml_fname,fid_out_shape,...
%    u1, v1, p1,vrml_seg_index,vrml_texture_fname_head)
function sub_gen_vrml_one(vtm_center,structure_index,output_vrml_fname,fid_out_shape,...
    p1,u1,v1,vrml_texture_fname_head,vrml_extension,vrml_seg_index,vrml_inside_out_transform,...
    vrml_write_mode,vrml_external_internal_texture_mode,vrml_zinit,vrml_display_tag)


absolute_P1=p1;
%%%%%%%%%% not essential but will rotate to a position for vrml viewer
transform_tag=1
if transform_tag ==1
    for i=1:3,
        absolute_P1(i,:)=absolute_P1(i,:)-vtm_center(i); %shift to center
    end
    
    %--------begin- below only to set th emodle in view when viewing, can be removed ----
    %used to fit model to vrml broweser, no actual fucntion,can be set to
    %T=[0 0 0]', R=rpyMat([0,0,0])
    T= [0,0,-vrml_zinit*0.7]';
    R=rpyMat([0,pi,0]);
    
    %if you are using multple combined model for vrml , don't do R,T
    %R=rpyMat([0,0,0]); %originbal 
    %T= [0,0,0]'; %originbal 
    
    
    [foo,nn]=size(absolute_P1);
    absolute_P1=R*absolute_P1+repmat(T,1,nn);
    for i=1:3,
        absolute_P1(i,:)=absolute_P1(i,:)+vtm_center(i); %shift back
    end
end
%--------end- the above is only to set the modle in view when viewing, can be removed ----

string_structure_index=num2str_lead0(vrml_seg_index (structure_index),3);
texture_fname=strcat('0_02texture_',string_structure_index,'.jpg');
texture_fname
im_texture0=imread(strcat(vrml_texture_fname_head,string_structure_index,vrml_extension));

[yyy,xxx,foo]=size(im_texture0);


screen_max_x=xxx
screen_max_y=yyy

ixcenter=screen_max_x/2
iycenter=screen_max_y/2

im_texture4vrml(:,:,1)=fliplr(im_texture0(:,:,1));
im_texture4vrml(:,:,2)=fliplr(im_texture0(:,:,2));
im_texture4vrml(:,:,3)=fliplr(im_texture0(:,:,3));

im_texture4vrml_2(:,:,1)=flipud(im_texture4vrml(:,:,1));
im_texture4vrml_2(:,:,2)=flipud(im_texture4vrml(:,:,2));
im_texture4vrml_2(:,:,3)=flipud(im_texture4vrml(:,:,3));

imwrite(im_texture4vrml,texture_fname);

switch structure_index
    case 1,
        transformed_model_x=absolute_P1(1,:);
        transformed_model_y=absolute_P1(2,:);
        transformed_model_z=absolute_P1(3,:);
        %         tri_iix=(u1 + 0.5)*screen_max_x;
        %         tri_iiy=(v1 + 0.5)*screen_max_y;
        tri_iix=u1+ixcenter;
        tri_iiy=v1+iycenter;
        
        [foo,n_features]=size(p1);
        %------------------------
        if vrml_display_tag >=1
            figure(703)
            hold on
            plot3(transformed_model_x,transformed_model_y,transformed_model_z,'r.')
            plot3(vtm_center(1),vtm_center(2),vtm_center(3),'c+');
            rotate3d on;
            xlabel('x-axis');
            ylabel('y-axis');
            zlabel('z-axis');
            title('VRML  transformed model');
        end
        %[foo,n_features]=size(p1);
        %------------------------------------------------------
        
    otherwise,
        'wrong P check, inside gc',pause
end

if vrml_display_tag >=1
    figure(704)
    clf
    image(im_texture4vrml_2)
    %image(im_texture0)
    hold on
    plot(tri_iix,tri_iiy,'r.' )
end

tri_iix=tri_iix;
tri_iiy=tri_iiy;

u=tri_iix/screen_max_x;
v=tri_iiy/screen_max_y;

TRI = delaunay(tri_iix,tri_iiy); 
%%%%%%%% Man Ki : check the normal of the triangle and convert it to the correct direction %%%%%%%
%external_internal_texture_mode=0; %1 or 0
TRI = cv_fix_tri_dir2(TRI,tri_iix,tri_iiy,vrml_external_internal_texture_mode);

%%%%%%%% Man Ki %%%%%%%%%%%%%%%
if vrml_display_tag >=1
    figure(705)
    clf
    subplot(2,2,1);
    imagesc(im_texture4vrml_2);
    
    subplot(2,2,2);
    imagesc(im_texture4vrml_2);
    title('im-texture4vrml-2');
    hold on;
    [foo,n_features]=size(tri_iiy);
    trimesh(TRI,tri_iix,tri_iiy,zeros(n_features,1)); 
    [n_TRI,foo]=size(TRI);
end


if vrml_display_tag >=1
    figure(706)
    clf
    imagesc(im_texture4vrml_2);
    hold on;
    [foo,n_features]=size(tri_iiy);
    trimesh(TRI,tri_iix,tri_iiy,zeros(n_features,1)); 
end
[n_TRI,foo]=size(TRI);

if vrml_write_mode==1 %write_mode==1 is write many file mode, 0 for write one file,
    [fid_out_shape,errmsg] = fopen(output_vrml_fname,'w');
    if fid_out_shape == -1
        disp(' ');
        disp(['VRMLplot error - unable to open ' outfile ' for writing.']);
        clear out_shape_file;
        return;
    end
    sub_write_vrml_header(fid_out_shape);
end

%fprintf(fid_out_shape,'#VRML V2.0 utf8\n');
%fprintf(fid_out_shape,'Group {\n');
%fprintf(fid_out_shape,'  children [\n');
%-------------------------------------------------------------------------
%------------ start file writing ----------------------
fprintf(fid_out_shape,'Shape {\n');
fprintf(fid_out_shape,'   appearance Appearance {\n');
fprintf(fid_out_shape,'      texture ImageTexture {\n');

%fprintf(fid_out_shape,'         url "im_texture.jpg"\n');
fprintf(fid_out_shape,'         url "%s" \n',texture_fname');

fprintf(fid_out_shape,'      }\n');
fprintf(fid_out_shape,'   }\n');
fprintf(fid_out_shape,'   geometry IndexedFaceSet {\n');
fprintf(fid_out_shape,'      coord DEF COORD Coordinate {\n');
fprintf(fid_out_shape,'         point [\n');

%------------------111111111111  Writing geometry IndexedFaceSet ---------------------
%disp('Writing geometry IndexedFaceSet')
for nn=1:n_features,
    fprintf(fid_out_shape,'%3.4f %3.4f %3.4f ,\n',...
        transformed_model_x(nn),...
        transformed_model_y(nn),...
        transformed_model_z(nn));
end

fprintf(fid_out_shape,'         ]\n');
fprintf(fid_out_shape,'      }\n');
%fprintf(fid_out_shape,'      solid TRUE')  %%%?????????????????
fprintf(fid_out_shape,'      coordIndex [\n');
%%%%%*********************************************************
%%%%% form index sequence for tiangles %%%%%%%%%%%

%------------------222222222222222 triangle coordIndex ---------------------
%disp('Writing  triangle coordIndex');

for nn=1:n_TRI,
    fprintf(fid_out_shape,'%d %d %d -1,\n',...
        TRI(nn,1)-1,... %vrml starts from 0, delan starts from 1, so it need to -1 	   
        TRI(nn,2)-1,... %vrml starts from 0, delan starts from 1, so it need to -1 	   
        TRI(nn,3)-1);  %vrml starts from 0, delan starts from 1, so it need to -1   
end


%3.2fprintf(fid_out_shape,'          0 1 2  -1,\n')
fprintf(fid_out_shape,'      ]\n');
fprintf(fid_out_shape,'      texCoord DEF TEXCOORD TextureCoordinate {\n');
fprintf(fid_out_shape,'      point [  \n');


%-----33333333333333333 texCoord DEF TEXCOORD TextureCoordinate ---------------------
%disp('Writing texCoord DEF TEXCOORD TextureCoordinate');
for nn=1:n_features,
    fprintf(fid_out_shape,'%3.4f %3.4f,\n',...
        u(nn),v(nn));
    %      	(ixx(nn)+ixcenter)/640,...
    %          (iyy(nn)+iycenter)/480);
end
fprintf(fid_out_shape,'           ]\n');
fprintf(fid_out_shape,'      }\n');

fprintf(fid_out_shape,'      texCoordIndex [\n');
%0 1 2   -1\n')
%%%%%*********************************************************
%%%%% form teCoordIndex sequence for texture mapping %%%%%%%%%%%

%------------------444444444444444444  texture  texCoordIndex triangle sequence  ---------------------
%disp('Writing texture  texCoordIndex triangle sequence ');

for nn=1:n_TRI,
    fprintf(fid_out_shape,'%d %d %d -1,\n',...
        TRI(nn,1)-1,... %vrml starts from 0, delan starts from 1, so it need to -1 	   
        TRI(nn,2)-1,... %vrml starts from 0, delan starts from 1, so it need to -1 	   
        TRI(nn,3)-1);  %vrml starts from 0, delan starts from 1, so it need to -1   
end
%-------------------------------------------------------------------------
fprintf(fid_out_shape,'      ]\n');
fprintf(fid_out_shape,'   }\n');
fprintf(fid_out_shape,'}\n');

%###########################################################################
%--  -tail-  -tail-  -tail-  -tail-  -tail-  -tail-  -tail-  -tail-  -tail-  
if vrml_write_mode==1 %write_mode==1 is write many file mode, 0 for write one file,
    sub_write_vrml_tailer(fid_out_shape);
    fclose(fid_out_shape);
end


disp(sprintf('--- one model vrml file written -------structure_index=%d',structure_index));
return

%FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
function sub_write_vrml_header(fid_out_shape)
fprintf(fid_out_shape,'#VRML V2.0 utf8\n');
fprintf(fid_out_shape,'Group {\n');
fprintf(fid_out_shape,'  children [\n');
return

%###########################################################################
%--  -tail-  -tail-  -tail-  -tail-  -tail-  -tail-  -tail-  -tail-  -tail-  
function sub_write_vrml_tailer(fid_out_shape)
fprintf(fid_out_shape,'      ]\n');
fprintf(fid_out_shape,'   }\n');
return


