%function [rpy_ix,rpy_iy,rpy_ival,dos_return]=features_extract1 (dir_work)

% A KLT_Feature contains an (x,y) location and a value. (KLT_locType is equal to float.) The value is interpreted as follows: 
% 
%      1.A positive value means the feature has just been found by KLTSelectGoodFeatures() or KLTReplaceLostFeatures(). 
%      2.KLT_TRACKED (0) means the feature has been successfully tracked. 
%      3.KLT_NOT_FOUND (-1) means that no feature could be found. For example, if the user attempts to find 150 features in an image, but
%           only 125 can be found, then the remaining 25 will be assigned a value of KLT_NOT_FOUND. 
%      4.KLT_SMALL_DET (-2) indicates that the feature has been lost due to the 2 by 2 gradient matrix having a small determinant. 
%      5.KLT_MAX_ITERATIONS (-3) means that the feature has been lost because the number of iterations exceeded the maximum allowable. 
%      6.KLT_OOB (-4) means that the feature has been lost because it was out of bounds (i.e., it was too close to the image border). 
%      7.KLT_LARGE_RESIDUE (-5) means that the feature has been lost because the residue between the two feature windows was too large. 
function [feature,dos_return]=ct_1extract_raw_features (in,cam,wdir,feature)

% case a) a value >0, meaas the position x or y of that feature 
% case b) -9010, a feature will appear in that row but not yet
% case c) -9020, a feature being tracked has been lost
disp('Inside features_extraction1.m');
%load( strcat(wdir.test_dir_work,'para1'))

%///////////////////////////////////////////////////////////////////////////////////////
%############################ update track mode  #####################################
out_directory=strcat(wdir.temp_pgm);
cv_klt_im2pgm9(wdir.test_dir_name,wdir.file_head,in.extension,...
    in.base_frame,...
    in.n_frames,out_directory); %convert image (.jpg or .bmp) into .pgm

%disp(sprintf('kkkkkkkkkkkkkkk klt_36 will start: in.sector_index= %d kkkkkkkkkkkkkkkkkk',in.sector_index))
disp(sprintf('kkkkkkkkkkkkkkk klt_36 will start:  kkkkkkkkkkkkkkkkkk'))
command_string1=sprintf...
    ('klt36 %s %s %d %d %d',wdir.input_pgm_dir, wdir.output_features_dir,...   
    in.n_frames-1,in.n_features_per_frame,in.klt_replace_tag);

command_string1

dos_return=dos(command_string1);

%	 !command_bat.bat
if dos_return <0 %the klt dos command may be bad
    disp('the klt dos command may be bad, please check');
    return
end
%---------------------------------------------------------------------------------------
load(strcat(wdir.output_features_dir, 'features2_x.txt'),'features2_x'); %extract features_x
load(strcat(wdir.output_features_dir, 'features2_y.txt'),'features2_y'); %extract features_x
load(strcat(wdir.output_features_dir, 'features2_val.txt'),'features2_val'); %extract features_x

fname_features2_x=strcat(wdir.output_features_dir,'features2_','x.mat');
fname_features2_y=strcat(wdir.output_features_dir,'features2_','y.mat');
fname_features2_val=strcat(wdir.output_features_dir,'features2_','val.mat');

save_features_tag=1;
if save_features_tag==1
    %use it if you wnt to save features
    save(fname_features2_x,'features2_x'); %output different sector features.
    save(fname_features2_y,'features2_y');
    save(fname_features2_val,'features2_val');
end

%in.save_at_current_dir_for_examination=1 if you wan to save data to view %hard coded to stop save
if exist('in.save_at_current_dir_for_examination')==1
    %%%%%%%% save file at current directiory for examination only
    save('features2_x.txt','features2_x','-ascii');% save file at images dir. for fast reload
    save('features2_y.txt','features2_y','-ascii');
    save('features2_val.txt','features2_val','-ascii');
end      

%############################ update track mode #####################################
%    if update_track_mode==0
%    	if update_track_mode==0 %fast reload without tracking again
%    		fname_features2_x=strcat(dir_name,'features2_',int2str(index_model),'x');
% 			fname_features2_y=strcat(dir_name,'features2_',int2str(index_model),'y');
% 			fname_features2_val=strcat(dir_name,'features2_',int2str(index_model),'val');
% 
%       %matlab ver6%		features_x=load(fname_features2_x) ; %extract features_x; size is number of features x frame size
% 		%matlab ver6%       features_y=load(fname_features2_y) ; %extract features_x
% 		%in matlab5 or 6 load(namex) will return it to the matrix called namex
%      	load (fname_features2_x); %obtain features_x
%      	load (fname_features2_y); %obtain features_y
%      	load (fname_features2_val); %obtain features_val
%    	end
% 	end
%    
%#######################################################################################

end %end fo feature extarction   



