%non replace mode feature filter
function [feature,wdir]=ct_20_feat_filt(in,feature,cam,wdir)

%in.threshold_gray=50;

disp('ffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffff');
disp('  [feature,wdir]=ct_20_feat_filt(in,feature,cam,wdir)');

fname_features2_x=strcat(wdir.output_features_dir,'features2_','x.mat');
fname_features2_y=strcat(wdir.output_features_dir,'features2_','y.mat');
fname_features2_val=strcat(wdir.output_features_dir,'features2_','val.mat');

load(fname_features2_x,'features2_x'); %output different sector features.
load(fname_features2_y,'features2_y');
load(fname_features2_val,'features2_val');

feature.raw_ix=features2_x;
feature.raw_iy=features2_y;
feature.raw_ival=features2_val;

ix=feature.raw_ix;
iy=feature.raw_iy;
iv=feature.raw_ival;

%--------------------------------------------------------------------------
% set all unused codes to -9xxx
%v=find(ix<-9000); ix(v)=NaN; iy(v)=NaN;
id=find(iv < 0); 
ix(id)= feature.feature_unused_code;
iy(id)= feature.feature_unused_code;
iv(id)= feature.feature_unused_code;

%----------  feature filter  step 1---------------------------
%sub_remove_unused_features (-ve ival) if needed
[nnn,ttt]=size(iv)
n2=0;
for n=1:nnn
    if feature.raw_ival(n,1) >= -9000 %valid, see if the row has feature or not, -ve val has no feature
        n2=n2+1;
        temp_ix(n2,:)=ix(n,:);
        temp_iy(n2,:)=iy(n,:);
        temp_iv(n2,:)=iv(n,:);
    end
end    

ix=temp_ix;
iy=temp_iy;
iv=temp_iv;

%---------- reformat replace mode ----------------------------------
if in.klt_replace_tag==1
    [ix,iy,iv]=sub_reformat_replace_mode_features(ix,iy,iv,in,feature);
end

%---------- all mode feature filter  step 2 ---------------------------
if in.klt_check_xy_limit_tag ==1
    disp('********************** sub_check xy motion_features_filter ****************************** ');
    [ix,iy,iv]=sub_check_xy_limit_features_filter(ix,iy,iv,in);
end

if in.klt_feature_motion_tag==1
    disp('********************** sub_motion_features_filter ****************************** ');
    [ix,iy,iv]=sub_motion_features_filter(ix,iy,iv,in);
end

% to be added ---------- non-replace mode gray_level filter if needed ---------------------------

%#######################################################################################
%--------- now features are found and filtered -----------------------------------------
%---------- adjust coordinates --------------------------------------------
%features_x left to right top down; iix right to left, bottom to top
%to fix a bug here
%[nnn,ttt]=size(iv);

clear iix iiy;
[nnn,ttt]=size(iv);
for n=1:nnn,
    for t=1:ttt,
        if  iv(n,t) >= -9000 %control code (negative) will not change
            iix(n,t)=cam.screen_max_x-ix(n,t)+1 - cam.ixcenter; %adjust to rpy corrdinate
            iiy(n,t)=cam.screen_max_y-iy(n,t)+1 - cam.iycenter;
        else
            iix(n,t)= feature.feature_unused_code; %feature.feature_lost_code;
            iiy(n,t)= feature.feature_unused_code; %feature.feature_lost_code;
        end
    end
end

% for t=1:ttt
%   t
%   v=find (iv(:,t) >= -9000);
%   iix(v,t)=cam.screen_max_x-ix(v,t)+1 - cam.ixcenter; %adjust to rpy corrdinate
%   iiy(v,t)=cam.screen_max_y-iy(v,t)+1 - cam.iycenter; %adjust to rpy corrdinate
% end

feature.rpy_ix=iix;
feature.rpy_iy=iiy;
feature.rpy_iv=iv;

disp('My warning, Check that some frames are stationary, don"t use motion fiilter');


return





%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%







%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%




%########################################################
%#                                                      #
%#                                                      #
%#                       FUNCTIONS                      #
%#                                                      #
%#                                                      #
%########################################################
function [out_ix,out_iy,out_iv]=sub_reformat_replace_mode_features(ix,iy,iv,in,feature)

[nnn,ttt]=size(iv);
%============ replace mode reformate ===========================

%------------------ for every feature , check what happen for each frame_t ---------------------
n2=0;
for n= 1:nnn,
    % --------------  frame tt=1:   features2_ the first feature must be good
    n2=n2+1;
    temp_ix(n2,1)=ix(n,1);
    temp_iy(n2,1)=iy(n,1);
    temp_iv(n2,1)=iv(n,1);
    
    %-------------- frame tt=2:max_t : the late comers will be represented by 
    for t=2:ttt, %check if there it has been a bad feature
        if  iv(n,t) > 0.01 %a new feature is found
            %fill the rest of th row 9020 because current feature has beeb lost
            temp_ix(n2,t:ttt)= feature.feature_lost_code;
            temp_iy(n2,t:ttt)= feature.feature_lost_code;
            temp_iv(n2,t:ttt)= feature.feature_lost_code;
            %----------- write next good feature 
            n2=n2+1;
            temp_ix(n2,1:t-1)= feature.feature_will_come_code;
            temp_iy(n2,1:t-1)= feature.feature_will_come_code;
            temp_iv(n2,1:t-1)= feature.feature_will_come_code;
            
            temp_ix(n2,t)=ix(n,t);
            temp_iy(n2,t)=iy(n,t);
            temp_iv(n2,t)=iv(n,t);
        end
        if  iv(n,t) == 0  %keeping a valid feature
            temp_ix(n2,t)=ix(n,t);
            temp_iy(n2,t)=iy(n,t);
            temp_iv(n2,t)=iv(n,t);
        end
    end
end
%----------------------
out_ix=temp_ix;
out_iy=temp_iy;
out_iv=temp_iv;
return


%FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFf
%                       sub_check_xy_limit_features_filter
%FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFf
function [out_ix,out_iy,out_iv]=sub_check_xy_limit_features_filter(ix,iy,iv,in)
in
in.features_xy_limits
[nnn,ttt]=size(iv);

%n_features=n_features_per_frame
%max_t=n_frames
n2=0;
for n=1:nnn,
    good_xy_limits_features_tag='pass';
    for t=1:ttt,
        %determine which feature is bad --nnnnnnnnnn  ****** ***********
        if  iv(n,t) > -9000 %a valid ix,iy point
            if    ~( in.features_xy_limits(1) < ix(n,t) & ix(n,t) < in.features_xy_limits(2) &...
                    in.features_xy_limits(3) < iy(n,t) & iy(n,t) < in.features_xy_limits(4) ) %see above | and ~
                
                good_xy_limits_features_tag='fail';
                break %onece it fails, the whole feature list is discarded
            end      
        end
    end
    
    if good_xy_limits_features_tag =='pass';
        n2=n2+1;
        out_ix(n2,:)=ix(n,:);
        out_iy(n2,:)=iy(n,:);
        out_iv(n2,:)=iv(n,:);
    end
end
return
% end of   sub_check_xy_limit_features_filter



%FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFf
% 2222222222222222222222       sub_motion_features_filter
%FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFf
function [out_ix,out_iy,out_iv]=sub_motion_features_filter(ix,iy,iv,in)

[nnn,ttt]=size(iv);

%n_features=n_features_per_frame
%max_t=n_frames
n2=0;
for n= 1:nnn,
    if mod(n,100)==0, %display opnly 
        disp(sprintf('sub_motion_filter %d',n));
    end
    
    good_motion_features_tag='pass';
    for t=1:ttt-1 %sum of all motions
        if (iv(n,t) > -9000 & iv(n,t+1) > -9000) % a valid ix,iy point
            pixel_dx=sqrt( (ix(n,t) - ix(n,t+1))^2);
            pixel_dy=sqrt( (iy(n,t) - iy(n,t+1))^2);
            
            if ~( (in.features_motion_limits(1) < pixel_dx & pixel_dx < in.features_motion_limits(2))...
                    | ... %this has to be or, not and
                    (in.features_motion_limits(3) < pixel_dy & pixel_dy < in.features_motion_limits(4)))
                good_motion_features_tag= 'fail'; %if the pixel moves too fast or slow one time the hwole feature is discarded 
                break  ;
            end
        end    
    end
    
    if good_motion_features_tag =='pass';
        n2=n2+1;
        out_ix(n2,:)=ix(n,:);
        out_iy(n2,:)=iy(n,:);
        out_iv(n2,:)=iv(n,:);
    end
end
return
% end of  sub_motion_features_filter




