function view101(view101_infile,syn_tag)
if nargin<2, syn_tag=0; end %default is real

if syn_tag==1;
    load('syn_dat')
    syn_trans(1:3,:)= syn_trans_angles(1:3,:); %original data
    syn_angles(1:3,:)= syn_trans_angles(4:6,:);
end

load(view101_infile)

model = [model; ones(size(model(1,:)))];
[N,T]=size(ix);

%%%%%%%%%%%%%%%%%%%% 1 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
figure(451)
hold on
plot_title('cv_view101: object in motion, o=found, .=syn_data')
e=[];
for i=1:T
    plot(ix(:,i),iy(:,i),'.');      %plot observations
    hold on
    X = rt(:,:,i)*model;
    plot(flen*X(1,:)./X(3,:), flen*X(2,:)./X(3,:), 'o');
    axis([min(min(ix)),max(max(ix)),min(min(iy)),max(max(iy))]);
    hold off
    e=[e flen*X(1,:)./X(3,:)-ix(:,i)' flen*X(2,:)./X(3,:)-iy(:,i)'];
    %pause(0.2); %use this to see track movie
end

sqrt(sum(e.^2)*2/length(e))

%load lowe201out   %get syn data
%load syn_dat   %get syn data
disp=reshape(rt(:,4,:),3,[]);

%%%%%%%%%%%%%%%%%%%% 2 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
figure(452)
hold on
if syn_tag==1
    subplot(3,1,1); plot(syn_trans(1,:),'b:'); hold on; plot(disp(1,:),'g+-');ylabel('X translation');
    subplot(3,1,2); plot(syn_trans(2,:),'b:'); hold on; plot(disp(2,:),'g+-');ylabel('Y translation');
    subplot(3,1,3); plot(syn_trans(3,:),'b:'); hold on; plot(disp(3,:),'g+-');ylabel('Z translation');
else
    subplot(3,1,1); plot(disp(1,:),'g+-');ylabel('X translation');
    subplot(3,1,2); plot(disp(2,:),'g+-');ylabel('Y translation');
    subplot(3,1,3); plot(disp(3,:),'g+-');ylabel('Z translation');
end
xlabel('Translation (pixels) VS frame index:  g+-=found101, ro-=found202')
plot_title('cv_view101: Translation result')
%%%%%%%%%%%%%%%%%%%% 3 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
R=zeros(3,3,T);
for i=1:T
    if syn_tag==1
        R(:,:,i) = rpyMat(syn_angles(1:3,i));
    end
    An101(:,i)=rpyAng(rt(:,1:3,i));
end
An101_1=An101(:,1);
for i=1:T
    An101(:,i)=An101(:,i)-An101_1; %remove begin offset
end

figure(453)
hold on
if syn_tag==1
    plot((180/pi)*rotate_angles(R),'b:');
end
hold on
plot((180/pi)*rotate_angles(rt(:,1:3,:)),'g+-');
plot_title('cv_view_101:rotational degrees VS frame: b:=real, g+-=found101, ro-=found202')

%%%%%%%%%%%%%%%%%%%%%%%%%   4  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
figure(454)
hold on
if syn_tag==1
   subplot(3,1,1);plot((180/pi)*syn_angles(1,:),'b:');hold on;plot((180/pi)*An101(1,:),'g+-');
   ylabel('Yaw angle');

   subplot(3,1,2); plot((180/pi)*syn_angles(2,:),'b:'); hold on; plot((180/pi)*An101(2,:),'g+-');
   ylabel('Pitch angle');

    subplot(3,1,3); plot((180/pi)*syn_angles(3,:),'b:'); hold on; plot((180/pi)*An101(3,:),'g+-');
    ylabel('Roll angle');
else
    subplot(3,1,1);  plot((180/pi)*An101(1,:),'g+-');  ylabel('Yaw angle');

    subplot(3,1,2);  plot((180/pi)*An101(2,:),'g+-'); ylabel('Pitch angle');
    
    subplot(3,1,3);  plot((180/pi)*An101(3,:),'g+-'); ylabel('Roll angle');
end
xlabel('Rotational angles (degrees) VS frame index : g+-=found101, ro-=found202')
plot_title('cv_view101.m: Rotational vs t')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%
%%%        fucntions                                             %%%%%
%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% function angles = rotate_angles(R)  %given R, return the rotated angles from R(:,:,1)
% T = size(R,3);      %R=3*3*T
% angles=zeros(1,T);
% for t=1:T
%     r = R(:,:,t)*R(:,:,1)';   %Rn=r*R1 => r=Rn*R1'
%     A = 0.5*(r-r');
%     a = 0.5*sum(sum(A.^2));
%     angles(t) = asin(sqrt(a));
% end

function R = rpyMat (angs)
cosA = cos (angs(3));
sinA = sin (angs(3));
cosB = cos (angs(2));
sinB = sin (angs(2));
cosC = cos (angs(1));
sinC = sin (angs(1));

cosAsinB = cosA .* sinB;
sinAsinB = sinA .* sinB;

R = [ cosA.*cosB  cosAsinB.*sinC-sinA.*cosC  cosAsinB.*cosC+sinA.*sinC ;
    sinA.*cosB  sinAsinB.*sinC+cosA.*cosC  sinAsinB.*cosC-cosA.*sinC ;
    -sinB            cosB.*sinC                 cosB.*cosC         ];
