function view201()
load lowe201out

ix=feature.rpy_ix;
iy=feature.rpy_iy;
model = out.found_raw_model;
flen=cam.flen;
RT = out.RT_solutions;

[N,T]=size(ix);

figure(461)
clf
e=[];
for i=1:T
    plot(ix(:,i),iy(:,i),'.');      %plot observations
    hold on
    X = rpyMat(RT(4:6,i))*model + repmat(RT(1:3,i),1,N);
    plot(flen*X(1,:)./X(3,:), flen*X(2,:)./X(3,:), 'o');
    axis([min(min(ix)),max(max(ix)),min(min(iy)),max(max(iy))]);
    hold off
    e=[e flen*X(1,:)./X(3,:)-ix(:,i)' flen*X(2,:)./X(3,:)-iy(:,i)'];
    pause(0.2);
end
plot_title('cv_view201.m');

sqrt(sum(e.^2)*2/length(e))

real_trans(1:3,:)= syn.real_trans_angles(1:3,:); %original data
real_angles(1:3,:)= syn.real_trans_angles(4:6,:);

figure(462)
subplot(3,1,1); plot(real_trans(1,:),'b.'); hold on; plot(RT(1,:),'go');
subplot(3,1,2); plot(real_trans(2,:),'b.'); hold on; plot(RT(2,:),'go');
subplot(3,1,3); plot(real_trans(3,:),'b.'); hold on; plot(RT(3,:),'go');

for i=1:T       %convert euler angles to R matrix
    R(:,:,i) = rpyMat(real_angles(1:3,i));
    Rtrack(:,:,i) = rpyMat(RT(4:6,i));
end
plot_title('cv_view201.m');


figure(463)
plot(rotate_angles(R),'b');
hold on
plot(rotate_angles(Rtrack),'g');
plot_title('cv_view201.m');


function angles = rotate_angles(R)  %given R, return the rotated angles from R(:,:,1)
T = size(R,3);      %R=3*3*T
angles=zeros(1,T);
for t=1:T
    r = R(:,:,t)*R(:,:,1)';   %Rn=r*R1 => r=Rn*R1'
    A = 0.5*(r-r');
    a = 0.5*sum(sum(A.^2));
    angles(t) = asin(sqrt(a));
end

function R = rpyMat (angs)
cosA = cos (angs(3));
sinA = sin (angs(3));
cosB = cos (angs(2));
sinB = sin (angs(2));
cosC = cos (angs(1));
sinC = sin (angs(1));

cosAsinB = cosA .* sinB;
sinAsinB = sinA .* sinB;

R = [ cosA.*cosB  cosAsinB.*sinC-sinA.*cosC  cosAsinB.*cosC+sinA.*sinC ;
    sinA.*cosB  sinAsinB.*sinC+cosA.*cosC  sinAsinB.*cosC-cosA.*sinC ;
    -sinB            cosB.*sinC                 cosB.*cosC         ];
