function view202(view202_infile,syn_tag)
if nargin<2, syn_tag=0; end %default is real

if syn_tag ==1
    load('syn_dat');   %get syn data
    syn_trans(1:3,:)= syn_trans_angles(1:3,:); %original data
    syn_angles(1:3,:)= syn_trans_angles(4:6,:);
end

load(view202_infile)
%load foo

model = [model; ones(size(model(1,:)))];
[N,T]=size(ix);

%%%%%%%%%%%%%%%%%%%%  1 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
figure(451)
clf
plot_title('cv_view202.m: object in motion, o=found, .=syn_data')
hold on
e=[];
for i=1:T
    plot(ix(:,i),iy(:,i),'.');      %plot observations
    hold on
    X = rt(:,:,i)*model;
    plot(flen*X(1,:)./X(3,:), flen*X(2,:)./X(3,:), 'o');
    axis([min(min(ix)),max(max(ix)),min(min(iy)),max(max(iy))]);
    hold off
    e=[e flen*X(1,:)./X(3,:)-ix(:,i)' flen*X(2,:)./X(3,:)-iy(:,i)'];
    %pause(0.2); %use this to see track movie
end

sqrt(sum(e.^2)*2/length(e))

%load lowe201out   %get syn data

disp=reshape(rt(:,4,:),3,[]);


%%%%%%%%%%%%%%%%%%%% 2 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
figure(452)
clf
hold on
if syn_tag==1
    subplot(3,1,1); plot(syn_trans(1,:),'b:'); hold on; plot(disp(1,:),'ro:');
    subplot(3,1,2); plot(syn_trans(2,:),'b:'); hold on; plot(disp(2,:),'ro:');
    subplot(3,1,3); plot(syn_trans(3,:),'b:'); hold on; plot(disp(3,:),'ro:');
    %plot_title('translation VS frame in pixles: b:=real, g+-=found101, ro-=found202')
    
else
    subplot(3,1,1); plot(disp(1,:),'ro:');
    subplot(3,1,2); plot(disp(2,:),'ro:');
    subplot(3,1,3); plot(disp(3,:),'ro:');
    %plot_title('translation VS frame in pixles: b:=real, g+-=found101, ro-=found202')
end



for i=1:T
    if syn_tag==1
        R(:,:,i) = rpyMat(syn_angles(1:3,i));
    end
    An202(:,i)=rpyAng(rt(:,1:3,i));
end
An202_1=An202(:,1);
for i=1:T
    An202(:,i)=An202(:,i)-An202_1; %remove begin offset
end
plot_title('cv_view202.m')
%%%%%%%%%%%%%%%%%%% 3 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
figure(453)
clf
hold on
if syn_tag==1
    plot((180/pi)*rotate_angles(R),'b:');
    hold on
end
plot((180/pi)*rotate_angles(rt(:,1:3,:)),'ro-');
plot_title('cv_view202.m:rotational degrees VS frame: b:=real, g+-=found101, ro-=found202')

%%%%%%%%%%%%%%%%%%%% 4 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
figure(454)
clf
hold on
if syn_tag==1
    subplot(3,1,1); plot((180/pi)*syn_angles(1,:),'b:'); hold on; plot((180/pi)*An202(1,:),'ro:');
    subplot(3,1,2); plot((180/pi)*syn_angles(2,:),'b:'); hold on; plot((180/pi)*An202(2,:),'ro:');
    subplot(3,1,3); plot((180/pi)*syn_angles(3,:),'b:'); hold on; plot((180/pi)*An202(3,:),'ro:');
else
    subplot(3,1,1); plot((180/pi)*An202(1,:),'ro:');
    subplot(3,1,2); plot((180/pi)*An202(2,:),'ro:');
    subplot(3,1,3); plot((180/pi)*An202(3,:),'ro:');
    
end

plot_title('cv_view202.m:rotational degrees VS frame: b:=real, g+-=found101, ro-=found202')



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%
%%%        fucntions                                             %%%%%
%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% function angles = rotate_angles(R)  %given R, return the rotated angles from R(:,:,1)
% T = size(R,3);      %R=3*3*T
% angles=zeros(1,T);
% for t=1:T
%     r = R(:,:,t)*R(:,:,1)';   %Rn=r*R1 => r=Rn*R1'
%     A = 0.5*(r-r');
%     a = 0.5*sum(sum(A.^2));
%     angles(t) = asin(sqrt(a));
% end

function R = rpyMat (angs)
cosA = cos (angs(3));
sinA = sin (angs(3));
cosB = cos (angs(2));
sinB = sin (angs(2));
cosC = cos (angs(1));
sinC = sin (angs(1));

cosAsinB = cosA .* sinB;
sinAsinB = sinA .* sinB;

R = [ cosA.*cosB  cosAsinB.*sinC-sinA.*cosC  cosAsinB.*cosC+sinA.*sinC ;
    sinA.*cosB  sinAsinB.*sinC+cosA.*cosC  sinAsinB.*cosC-cosA.*sinC ;
    -sinB            cosB.*sinC                 cosB.*cosC         ];
