function show_lowe316(syn_lowe316_test )

switch syn_lowe316_test 
    case 'syn'
%        genmultisequence
 %       lowe316b(10, 'syn_dat', 'lowe_316_syn_out')
    load lowe_316_syn_out
    case 'real'
    %real test
    %lowe316b(10,'cam1_cam2_data','lowe_316_out');
    load lowe_316_out
end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%plot models
K=2
for k=1:K       
    figure(k)
    
    m=modelcell{k};
    v=find(m(4,:)==1);      %get valid model point
    scatter3(m(1,v),m(2,v),m(3,v));
    axis equal
    title( sprintf('lowe316 model k=%d',k) )
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
figure(11)              %plot displacement error
hold off
clf

disp=scale*reshape(rt(:,4,:,1),3,[]);
ref=reshape(rtref(:,4,:),3,[]);
maxd=1.1*max(max(disp));
mind=min(min(disp));
subplot(3,1,1);  plot(disp(1,:),'ro:'); hold on
subplot(3,1,1); plot(ref(1,:),'b');
axis([0 T mind maxd]);
ylabel('tx');

subplot(3,1,2); plot(disp(2,:),'ro:'); hold on
subplot(3,1,2); plot(ref(1,:),'b');
axis([0 T mind maxd]);
ylabel('ty');

subplot(3,1,3); plot(disp(3,:),'ro:'); hold on
subplot(3,1,3); plot(ref(1,:),'b');
axis([0 T mind maxd]);
ylabel('tz');
xlabel('lowe316 , frames')
%legend('translations')
legend('found', 'ref' )

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
figure(12)              %plot angular error
clf
k=1; 
angles=zeros(T,1);
%for t=1:T %the first 2 frames are not right ??????????
for t=3:T %the first 2 frames are not right ??????????
    %     R1=rtref(1:3,1:3,t,k); %refrence , what does it mean?
    %     R2=rt(1:3,1:3,t,k);
    %     dR=R2'*R1;              %angular difference
    %     [n,angles(t)]=rodrigue_inv(dR);
    
    %    R1=rtref(1:3,1:3,t,k); %refrence , what does it mean?
    R2=rt(1:3,1:3,t,k);
    an=rpyang(R2);              %angular difference
    anx(1,t)=an(1)*(180/pi);
    any(1,t)=an(2)*(180/pi);
    anz(1,t)=an(3)*(180/pi);
    
    %    [n,angles(t)]=rodrigue_inv(dR);
end
subplot(3,1,1)
plot(anx);
ylabel('angle-x')

subplot(3,1,2)
plot(any);
ylabel('angle-y')

subplot(3,1,3)
plot(anz);
ylabel('angle-z')
xlabel('frames')

legend('lowe316,degrees')


