function F_Final=FundFrom8Point(pl, pr, NumOfPtCorrespondence)

%Convert the z coordintaes from focal to to 1 to suit the normalization
for i=1:NumOfPtCorrespondence
    pl(i, 3)  = 1;
    pr(i, 3) = 1;
end;
    
%Centroid of the two sets of points
MeanOfpl = mean(pl);
MeanOfpr = mean(pr);

TotalDistanceFromCentroidL = 0;
TotalDistanceFromCentroidR = 0;

%Calculate the mean distance from the centroid, scaled up by 1/sqrt(2)
for i=1:NumOfPtCorrespondence
    TempDiffL = pl(i, :) - MeanOfpl;
    TempDiffR = pr(i, :) - MeanOfpr;
    
    TotalDistanceFromCentroidL = sqrt((TempDiffL(1)*TempDiffL(1) + TempDiffL(2)*TempDiffL(2))) + TotalDistanceFromCentroidL ;
    TotalDistanceFromCentroidR = sqrt((TempDiffR(1)*TempDiffR(1) + TempDiffR(2)*TempDiffR(2))) + TotalDistanceFromCentroidR ;

end;

dl = TotalDistanceFromCentroidL/(NumOfPtCorrespondence*sqrt(2));
dr = TotalDistanceFromCentroidR/(NumOfPtCorrespondence*sqrt(2));

%The normamlization matrix 
Hl = [1/dl 0 -MeanOfpl(1)/dl; 0 1/dl -MeanOfpr(2)/dl; 0 0 1];
Hr = [1/dr 0 -MeanOfpr(1)/dr; 0 1/dr -MeanOfpr(2)/dr; 0 0 1];


for i=1:NumOfPtCorrespondence
    Normalized_pl(i,1:3) = (Hl*pl(i,:)')';
    Normalized_pr(i,1:3) = (Hr*pr(i,:)')';
end;
    
%Normalized_pl

%Create a linear system of N points with 9 unknowns
for i=1:NumOfPtCorrespondence
    %pr*F*pl
    %CFXX Coefficient of the XX term in A
    CF11 = Normalized_pr(i, 1)*Normalized_pl(i, 1);
    CF12 = Normalized_pr(i, 1)*Normalized_pl(i, 2);
    CF13 = Normalized_pr(i, 1)*Normalized_pl(i, 3);
    CF21 = Normalized_pr(i, 2)*Normalized_pl(i, 1);
    CF22 = Normalized_pr(i, 2)*Normalized_pl(i, 2);
    CF23 = Normalized_pr(i, 2)*Normalized_pl(i, 3);
    CF31 = Normalized_pr(i, 3)*Normalized_pl(i, 1);
    CF32 = Normalized_pr(i, 3)*Normalized_pl(i, 2);
    CF33 = Normalized_pr(i, 3)*Normalized_pl(i, 3);

    A(i, 1:9) = [CF11 CF12 CF13 CF21 CF22 CF23 CF31 CF32 CF33];
end;

%A

%Do svd to solve the homogeneous system
[A_U, A_S, A_V]  = svd(A);

%Get column vector in V corresponds to the least singular value in S
%The solution to the homogeneous system
F = [A_V(1:3, 9)'; A_V(4:6, 9)'; A_V(7:9, 9)'];


[F_U, F_S, F_V] = svd(F);
%F_S
%Force the F to be singular
F_S(3, 3) = 0;

F_Corrected = F_U*F_S*F_V';
F_Final = Hr'*F_Corrected*Hl;
