%find closest 2D dist between a point (x3,y3) and a line across two points
%d=distance 
%x,y=and location of the point on the line closest to x3,y3 
%see http://astronomy.swin.edu.au/~pbourke/geometry/pointline/
function [d,x,y]=dist_point_line(x1,y1,x2,y2,x3,y3)

numer=(x3-x1)*(x2-x1)+(y3-y1)*(y2-y1);
denom=((x2-x1)^2+(y2-y1)^2);
u=numer/denom;

x=x1+u*(x2-x1);
y=y1+u*(y2-y1);

d=sqrt((x-x3)^2+(y-y3)^2);

% %use pythagorus to verify d , if neccesary
% long_side=sqrt((x1-x3)^2+(y1-y3)^2);
% short_side=sqrt((x-x1)^2+(y-y1)^2);
% long_side^2 - short_side^2 - d^2
% 'the above value must be near to zero'

return
