%genmulti_rand: ix[1:N,1:K]
%generate data with random angle and disp
function genmulti()
output='syn_dat'; 
%output data: ix{K}, iy{K}, flen, zinit  (ix,iy are cell array)

N=1000;           %number of points per image
viewangle=15;   %half angle = 10 degree
%flen=848;
%flen=100;
flen=1;
zinit=flen*800;

%initial angle between cameras, e.g. to generate 3 cameras, select ANGLES(:,1:3)
Config=3;

if Config==1
    ANGLES(:,1)=[0;0;0];     %R1=[0;0;0], given, not much use
    N=2*N;                   %double the feature points to make good comparison with 2 cameras
elseif Config==2
    ANGLES(:,1)=[0;0;0];     %R1=[0;0;0], given, not much use
    ANGLES(:,2)=[0; pi/2; 0];  %right hand rotation at y-axis, cam looks at x dir   
else
    ANGLES(:,1)=[0;0;0];     %R1=[0;0;0], given, not much use
    ANGLES(:,2)=[0; pi/2; 0];  %right hand rotation at y-axis, cam looks at x dir         
    ANGLES(:,3)=[pi/2; 0; 0];
end

K=size(ANGLES,2);       %K=number of cameras, depends on your selection in prev lines

%init output variables in cell array
xycell=cell(K,2);
modelcell=cell(K,1);

%init model
model=randomcorridor(N,zinit);

%pure translation
a1=1:90;
a2=10:99;
One=ones(size(a1));
One10=ones(1,10);
One20=ones(1,20);

% t=[0 1 2 3 4 5 6 7 8 9 9*One  ;      %moving in xz dir first
%    0 0 0 0 0 0 0 0 0 0 0*One  ; 
%    0 1 2 3 4 5 6 7 8 9 a2    ];   
% a=[0 0 0 0 0 0 0 0 0 0 0*One  ;
%    0 0 0 0 0 0 0 0 0 0 a1     ; 
%    0 0 0 0 0 0 0 0 0 0 0*One ];

% t=[0:9     10:19;           %short test sequence
%    0*One10 0*One10;
%    0:9     9*One10];
% a=[0*One10  0*One10;
%    0*One10  0:9;
%    0*One10  0*One10];

% t=[0:9     9*One;           %circular sequence
%    0*One10 0*One;
%    0:9     9*One];
% a=[0*One10  0*One;
%    0*One10  a1;
%    0*One10  0*One];

t=[0:9     10:29;           %longer test sequence
   0*One10 0*One20;
   0:9     9*One20];
a=[0*One10  0*One20;
   0*One10  0:19;
   0*One10  0*One20];

% t=[0 0 0 0 0 0 0 0 0 0 0*One;         %stationary pure rotation
%    0 0 0 0 0 0 0 0 0 0 0*One;  
%    0 1 2 3 4 5 6 7 8 9 9*One];  
% 
% a=[0 0 0 0 0 0 0 0 0 0 0*One  ;
%    0 0 0 0 0 0 0 0 0 0 a1     ; 
%    0 0 0 0 0 0 0 0 0 0 0*One  ];

dinc=5*flen*t;
%Angles=(0.5*pi/99)*a;
Angles=0.02*a;
%Angles=0.05*a;

%gen sequence for k cameras
RK=zeros(3,3,K);

% for k=1:K
%     RK(:,:,k)=rpymat(ANGLES(:,k))
%     for t=1:T
%         rt(1:3,1:3,t,k)=RK(:,:,k)*rt1(1:3,1:3,t);
%     end
%     rt(1:3,4,:,k)=rt1(1:3,4,:);
%     [xycell{k,1},xycell{k,2},modelcell{k}]=gensequence(model,rt(:,:,:,k),flen,zinit,viewangle);
% end

N=size(model,2);
T=size(t,2);          %update the new T
rt=zeros(3,4,T,K);
for k=1:K
    RK(:,:,k)=rpymat(ANGLES(:,k));
    m=RK(:,:,k)*model;
    modelcell{k}=[m; ones(1,N)];  
    
    for t=1:T           %init rt of camera 1
        rt(:,1:3,t,k)=rpymat(RK(:,:,k)*Angles(:,t));
        rt(:,4,t,k)=RK(:,:,k)*dinc(:,t);
    end
    [xycell{k,1},xycell{k,2}]=gensequence(m,rt(:,:,:,k),flen,zinit,viewangle);
end

plotxy(xycell{2,1},xycell{2,2});

save syn_dat xycell modelcell rt RK zinit flen Config Angles
return

function plotxy(x,y)
figure(1)
T=size(x,2);

for t=1:T
    t
    v=find(~isnan(x(:,t)));
    plot(x(v,t),y(v,t),'.');
    xmax=1.1*max(max(x(v,t)));
    xmin=1.1*min(min(x(v,t)));
    ymax=1.1*max(max(y(v,t)));
    ymin=1.1*min(min(y(v,t)));
    axis([xmin,xmax,ymin,ymax]);
end
return

function [x,y,model]=gensequence(model,rt,flen,zinit,deg)
T=size(rt,3);
N=size(model,2);
x=repmat(NaN,N,T); y=repmat(NaN,N,T);
c=tan(deg*pi/180);
maxx=flen*tan(deg*pi/180);
%noise=maxx/100;
noise=maxx/400;
%noise=0;
for t=1:T
    P=rt(:,1:3,t)*(model-repmat(rt(:,4,t),1,N));
    tx=flen*(P(1,:)./P(3,:))';
    ty=flen*(P(2,:)./P(3,:))';
    
    tanx = abs(atan(tx));
    tany = abs(atan(ty));
    v1 = find(tanx<c & tany<c);  %get angle within the cone
    v2 = find(P(3,:)>0);
    v = intersect(v1,v2);
    lenv=length(v);    
    nx=normrnd(0,noise,lenv,1);
    ny=normrnd(0,noise,lenv,1);
    x(v,t)=tx(v)+nx;        
    y(v,t)=ty(v)+ny;
%     n=rand(lenv,1);
%     w=find(n>0.9);      %10% are NaN
%     nv=v(w);
%     x(nv,t)=NaN;
%     y(nv,t)=NaN;
end
%model=[model; ones(1,N)];
return

function R = rpymat (angs)
% Return the 3x3 rotation matrix described by a set of Roll, Pitch and Yaw angles.

cosA = cos (angs(3));
sinA = sin (angs(3));
cosB = cos (angs(2));
sinB = sin (angs(2));
cosC = cos (angs(1));
sinC = sin (angs(1));

cosAsinB = cosA .* sinB;
sinAsinB = sinA .* sinB;

R = [ cosA.*cosB  cosAsinB.*sinC-sinA.*cosC  cosAsinB.*cosC+sinA.*sinC ;
      sinA.*cosB  sinAsinB.*sinC+cosA.*cosC  sinAsinB.*cosC-cosA.*sinC ;
        -sinB            cosB.*sinC                 cosB.*cosC         ];
return

% function e = mserror(v)  %calc the mean square error
% e = sqrt(sum(v.^2)/(length(v)/2));

% %add random noise here
% v=find(~isnan(ix));
% nx=normrnd(0,noise,length(v),1);
% ny=normrnd(0,noise,length(v),1);
% ix(v)=ix(v)+nx;        
% iy(v)=iy(v)+nyf;
% 
% min_err = mserror([nx; ny])

%add 5% shot noise
% n = rand(M,N);
% v=find(n<0.05);
% ix(v)=ix(v)+10;
% iy(v)=iy(v)+10;

%add invalid point NaN to simulate occlusion
% n = rand(M,N);  %N*M array of value between 0-1
% v=find(n<0.1);  %select 10% of points
% ix(v)=NaN;
% iy(v)=NaN;

function model = randomcorridor(N,zinit)
%return a 3*N matrix contains random points on four walls
%front (north) wall
model=zeros(3,6*N);
x=rand(1,N); y=rand(1,N);
x=2*zinit*(x-0.5); 
y=2*zinit*(y-0.5); 
model(:,1:N)=[x; y; repmat(zinit,1,N)];

%south wall
x=rand(1,N); y=rand(1,N);
x=2*zinit*(x-0.5); 
y=2*zinit*(y-0.5); 
model(:,N+1:2*N)=[x; y; repmat(-zinit,1,N)];

%east wall
y=rand(1,N); z=rand(1,N);
y=2*zinit*(y-0.5); 
z=2*zinit*(z-0.5); 
model(:,2*N+1:3*N)=[repmat(zinit,1,N); y; z];

%west wall
y=rand(1,N); z=rand(1,N);
y=2*zinit*(y-0.5); 
z=2*zinit*(z-0.5); 
model(:,3*N+1:4*N)=[repmat(-zinit,1,N); y; z];

%top wall
x=rand(1,N); z=rand(1,N);
x=2*zinit*(x-0.5); 
z=2*zinit*(z-0.5); 
model(:,4*N+1:5*N)=[x; repmat(zinit,1,N); z];

%bottom wall
x=rand(1,N); z=rand(1,N);
x=2*zinit*(x-0.5); 
z=2*zinit*(z-0.5); 
model(:,5*N+1:6*N)=[x; repmat(-zinit,1,N); z];
return
