function angs = rpyang2 (R)

%R = [          cz*cy, sz*cx+cz*sy*sx, sz*sx-cz*sy*cx]
%    [         -sz*cy, cz*cx-sz*sy*sx, cz*sx+sz*sy*cx]
%    [             sy,         -cy*sx,          cy*cx]

sy = R(3,1);
cy = sqrt( R(1,1).* R(1,1) + R(2,1).* R(2,1) );
if abs(cy) > 1e-15
    sz = -R(2,1) ./ cy;
    cz =  R(1,1) ./ cy;
    sx = -R(3,2) ./ cy;
    cx =  R(3,3) ./ cy;
    angs = [atan2(sx,cx); atan2(sy,cy); atan2(sz,cz)];
else   %if cy=0, thus sy=1, ist col = [0;0;1], 3rd row = [1 0 0], so angs(2)=pi/2, angs(3)=0
    if sy > 0  %cz=1, sz=0
        sx = (R(1,2) + R(2,3)) ./ 2;
        cx = (R(2,2) - R(1,3)) ./ 2;
        angs = [atan2(sx,cx); -pi./2; 0];
    else %sy < 0
        sx = ( -R(1,2) + R(2,3)) ./ 2;
        cx = ( R(2,2) + R(1,3)) ./ 2;
        angs = [atan2(sx,cx); pi./2; 0];
    end
end

return
