function show_lowe321
load lowe321out
%plot_model(modelcell)
K=size(rt,4);
T=size(rt,3);
print_rt(rt,flen_real,pixel_size_m)
%plotxy(x,y)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%              functions                                 %%%%%%%%%%
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function plot_model(modelcell)
K=size(modelcell,1);
for k=1:K       
    figure(10*K+k)
    m=modelcell{k};
    v=find(m(4,:)==1);      %get valid model point
    scatter3(m(1,v),m(2,v),m(3,v));
    axis equal
    xlabel('x axis');
    ylabel('y axis');
    zlabel('z axis');
end
return
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%% khw %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [disps,angles]=print_rt(rt,flen_real,pixel_size_m)
K=size(rt,4);
T=size(rt,3);
figure(K*100+59)              %plot displacement error
hold off
clf
scale_factor=flen_real(1)*pixel_size_m(1)*1000; %wrt flen of first cam
disps=reshape(rt(:,4,:,1),3,[])*scale_factor;

maxd=1.1*max(max(disps));
mind=min(min(disps));

subplot(3,1,1);  plot(disps(1,:),'ro:'); ylabel('X');hold on
axis([1 T mind maxd]);

subplot(3,1,2); plot(disps(2,:),'ro:'); ylabel('Y');hold on
axis([1 T mind maxd]);

subplot(3,1,3); plot(disps(3,:),'ro:'); ylabel('Z');hold on
axis([1 T mind maxd]);
xlabel('translations in mm vs time t frames')

figure(K*100+58)              %plot angular error
clf
k=1; 
angles=zeros(3,T);
angles(:,1)=rpyang2(rt(1:3,1:3,1,k));    %get first angles
for t=2:T
    %was angles(:,t)=rpyang2(rt(1:3,1:3,t,k), but has problem when ang is large
    dR=rt(1:3,1:3,t,k)*rt(1:3,1:3,t-1,k)';
    ang=rpyang2(dR);
    angles(:,t)=angles(:,t-1)+ang;   %to avoid multiple solutions in rpyang2 when ang is large
end

% maxd=1.1*max(max(Angles));
% mind=min(min(Angles));
subplot(3,1,1);  plot(angles(1,:)*180/pi,'ro:');ylabel('angle1'); hold on
subplot(3,1,2); plot(angles(2,:)*180/pi,'ro:'); ylabel('angle2');hold on
subplot(3,1,3); plot(angles(3,:)*180/pi,'ro:'); ylabel('angle3');hold on
xlabel('rotation in degrees vs time t frames')

return
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function plotxy(x,y)
figure(1)
clf
T=size(x,2);

for t=1:T
    t
    v=find(~isnan(x(:,t)));
    plot(x(v,t),y(v,t),'.');
    xmax=1.1*max(max(x(v,t)));
    xmin=1.1*min(min(x(v,t)));
    ymax=1.1*max(max(y(v,t)));
    ymin=1.1*min(min(y(v,t)));
    %axis([xmin,xmax,ymin,ymax]);
    %axis([-400,400,-400,400]);
    axis([-0.3,0.3,-0.3,0.3]);
end
return

