function show_lowe321_rb
% one cam method the front cam is the reference

% 2 cam method the front cam is the reference
load lowe321out_1
rt1=rt;

load lowe321out_2
rt2=rt;

[gt_x,gt_y,gt_z,gt_an1,gt_an2,gt_an3]=rb_find_gt_motion;
%plot_model(modelcell)
K=size(rt2,4);
T=size(rt2,3);

%print_rt1(rt1,T);
print_rt_all(rt1,rt2,flen_real,pixel_size_m,gt_x,gt_y,gt_z,gt_an1,gt_an2,gt_an3)
print_paper_tdview
print_paper_rt(rt1,rt2,flen_real,pixel_size_m,gt_x,gt_y,gt_z,gt_an1,gt_an2,gt_an3)
%plotxy(x,y)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%              functions                                 %%%%%%%%%%
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%% khw %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [disps,angles]=print_paper_tdview(rt1,rt2,flen_real,pixel_size_m,gt_x,gt_y,gt_z,gt_an1,gt_an2,gt_an3)
load rb_path
%convert_ into abosluetr x motion as gt_x

figure(32) %fig3b
clf
hold on
max_d=0.03; %in meters
plot(-max_d,0,'k.');% make sure xy appears in the same magnitude
plot(max_d,max_d,'k.');% make sure xy appears in the same magnitude
% for i=1:N_steps-1
%    plot(gt_x,gt_z,'rs')
% end
text(-tdview_x(1)-0.001,tdview_z(1)+0.005,'time =1')
text(-tdview_x(100)-0.001,tdview_z(100),'time =100')

for i=1:N_steps-1
    plot(-tdview_x,tdview_z,'k^')
end
set(gca,'XDir','reverse')

ylabel('Z-axis in meters')
xlabel('X-axis in meters')
title('top down view of the robot motion')

return

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [disps,angles]=print_paper_rt(rt1,rt2,flen_real,pixel_size_m,gt_x,gt_y,gt_z,gt_an1,gt_an2,gt_an3)
%this is for making the figures for the multicam paper.

gt_x=gt_x; %make it into meters
gt_y=gt_y;
gt_z=gt_z;

pixel_size_m(1)=11*10^(-6); %khw pixel size for both canon-G3 (cam1)and canon-A70(cam2)are 11um
pixel_size_m(2)=11*10^(-6); %khw pixel size for both canon-G3 (cam1)and canon-A70(cam2)are 11um

%%%% as shown in the jpg file, use acdc to view it%%
flen_real(1)=7.19*10^(-3)/pixel_size_m(1); %khw 
flen_real(2)=7.19*10^(-3)/pixel_size_m(2); %khw
kk=flen_real(1)*pixel_size_m(1);

K=size(rt2,4);
T=size(rt2,3);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
figure(41) %multicam paper fig4a             %plot angular error
clf
k=1; 
%cam 1 &&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
angles1=zeros(3,T);
angles1(:,1)=rpyang2(rt1(1:3,1:3,1,k));    %get first angles
for t=2:T
    %was angles(:,t)=rpyang2(rt(1:3,1:3,t,k), but has problem when ang is large
    dR=rt1(1:3,1:3,t,k)*rt1(1:3,1:3,t-1,k)';
    ang=rpyang2(dR);
    angles1(:,t)=angles1(:,t-1)+ang;   %to avoid multiple solutions in rpyang2 when ang is large
end

%cam 2 &&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
angles2=zeros(3,T);
angles2(:,1)=rpyang2(rt2(1:3,1:3,1,k));    %get first angles
for t=2:T
    %was angles(:,t)=rpyang2(rt(1:3,1:3,t,k), but has problem when ang is large
    dR=rt2(1:3,1:3,t,k)*rt2(1:3,1:3,t-1,k)';
    ang=rpyang2(dR);
    angles2(:,t)=angles2(:,t-1)+ang;   %to avoid multiple solutions in rpyang2 when ang is large
end


maxd=2.1*max([max(angles2), max(gt_an1(1:T)), max(gt_an2(1:T)), max(gt_an3(1:T))] )*180/pi;
mind=2.1*min([min(angles2), min(gt_an1(1:T)), min(gt_an2(1:T)), min(gt_an3(1:T))] )*180/pi;
% maxd=1.1*max(max(Angles));
% mind=min(min(Angles));
% subplot(3,1,1);  plot(angles2(1,:)*180/pi,'ro:');ylabel('angle1'); hold on
% subplot(3,1,1);  plot(angles1(1,:)*180/pi,'gs:');ylabel('angle1'); hold on
% subplot(3,1,1);  plot(gt_an1(1,:)*180/pi,'bx:');
% axis([1 T mind maxd]);

plot(angles2(2,1:T)*180/pi,':ko'); ylabel('Pitch angle (degrees)');hold on
plot(angles1(2,1:T)*180/pi,':k+'); hold on
%plot(gt_an2(1:T)*180/pi,':kx'); 
legend('2-cam method','1-cam method','ground truth')
 
axis([1 120 mind maxd]);

% subplot(3,1,3); plot(angles2(3,:)*180/pi,'ro:'); ylabel('angle3');hold on
% subplot(3,1,3); plot(angles1(3,:)*180/pi,'gs:'); ylabel('angle3');hold on
% subplot(3,1,3); plot(gt_an3(1:T)*180/pi,'bx:'); 
% axis([1 T mind maxd]);

%xlabel('O= 2-cam method, += 1-cam method, X=ground truth : rotation vs time frame')
xlabel('Rotation vs time frame')

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
figure(42)%multicam paper fig4b     %plot displacement error
hold off
clf
%%%%%%%%%%%%%%% 1 cam trans ------------------
disps1=reshape(rt1(:,4,:,1),3,[]);
trans1x=disps1(1,1:T)*kk;
trans1y=disps1(2,1:T)*kk;
trans1z=disps1(3,1:T)*kk;
max_1x=max(trans1x)*kk;
max_1y=max(trans1y)*kk;
max_1z=max(trans1z)*kk;

%%%%%%%%%%%%%%% 2 cams trans ------------------
%scale_trans_scale=flen_real(1)*pixel_size_m(1)*1000; %wrt flen of first cam

disps2=reshape(rt2(:,4,:,1),3,[]);
trans2x=disps2(1,1:T)*kk; %make it into meters
trans2y=disps2(2,1:T)*kk;
trans2z=disps2(3,1:T)*kk;

%trans_scale=gt_z(T)/trans2z(T) %use ground truth to scale the output.
%trans_scale=1*(gt_z(T)/trans2z(T)) %use ground truth to scale the output.
trans_scale=50*(gt_x(T)/trans2z(T)) %use ground truth to scale the output.


max_2x=max(trans2x);
max_2y=max(trans2y);
max_2z=max(trans2z);



max_gt_z=max(gt_z(1:T))
maxd=2.2*max([max(trans2x), max(trans1x)]);
mind=2.2*min([min(trans2x), min(trans1x)]);



 plot( (trans2x(1,1:T)*trans_scale),':ko'); ylabel('Translation X-meters');hold on
 plot( (trans1x(1,1:T)*trans_scale),':k+'); 
% plot(gt_x(1:T)*trans_scale,':kx'); 
% plot(-gt_x(1:T),':kx'); 
 %legend('2-camera method','Single camera method','ground truth')
 %plot(trans2z*trans_scale,':r.'); 
 
%axis([1 T -maxd maxd]);

% plot(trans2y,'ro:'); ylabel('Y-meters');hold on
% plot(trans1y,'gs:'); 
% plot(gt_y(1:T),'bx:');
% axis([1 T -maxd maxd]);

% subplot(4,1,3); plot(trans2z,'ro:'); ylabel('Z-meters');hold on
% subplot(4,1,3); plot(trans1z,'gs:'); 
% %subplot(4,1,3); plot(gt_z(1:T),'bx:'); %data massage

% subplot(4,1,4); plot((trans2z/max_2z)*max_1z,'ro:'); ylabel('Z-meters');hold on
% subplot(4,1,4); plot((trans1z/max_1z)*max_1z,'gs:');
% subplot(4,1,4); plot((gt_z(1:T)/max_gt_z)*max_1z,'bx:'); %data massage
% %axis([1 T 0 maxd]);

%xlabel('O= 2-cam method, += 1-cam method, X=ground truth : translation vs time frame')
xlabel('X-translation vs time frame')

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

return




















%%%%%%%%%%%%%%%%%% khw %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [disps,angles]=print_rt_all(rt1,rt2,flen_real,pixel_size_m,gt_x,gt_y,gt_z,gt_an1,gt_an2,gt_an3)

gt_x=gt_x; %make it into meters
gt_y=gt_y;
gt_z=gt_z;

pixel_size_m(1)=11*10^(-6); %khw pixel size for both canon-G3 (cam1)and canon-A70(cam2)are 11um
pixel_size_m(2)=11*10^(-6); %khw pixel size for both canon-G3 (cam1)and canon-A70(cam2)are 11um

%%%% as shown in the jpg file, use acdc to view it%%
flen_real(1)=7.19*10^(-3)/pixel_size_m(1); %khw 
flen_real(2)=7.19*10^(-3)/pixel_size_m(2); %khw
kk=flen_real(1)*pixel_size_m(1);

K=size(rt2,4);
T=size(rt2,3);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
figure(359)              %plot displacement error
hold off
clf
%%%%%%%%%%%%%%% 1 cam trans ------------------
disps1=reshape(rt1(:,4,:,1),3,[]);
trans1x=disps1(1,1:T)*kk;
trans1y=disps1(2,1:T)*kk;
trans1z=disps1(3,1:T)*kk;
max_1x=max(trans1x)*kk;
max_1y=max(trans1y)*kk;
max_1z=max(trans1z)*kk;

%%%%%%%%%%%%%%% 2 cams trans ------------------
%scale_trans_scale=flen_real(1)*pixel_size_m(1)*1000; %wrt flen of first cam


disps2=reshape(rt2(:,4,:,1),3,[]);
trans2x=disps2(1,1:T)*kk; %make it into meters
trans2y=disps2(2,1:T)*kk;
trans2z=disps2(3,1:T)*kk;

max_2x=max(trans2x);
max_2y=max(trans2y);
max_2z=max(trans2z);

max_gt_z=max(gt_z(1:T))
%maxd=1.0*max([max(disps2), max(gt_x(1:T)), max(gt_y(1:T)), max(gt_z(1:T))] );
%mind=1.0*min([min(disps2), min(gt_x(1:T)), min(gt_y(1:T)), min(gt_z(1:T))] );
maxd=1.0*max([max(disps2), max(gt_x(1:T)), max(gt_y(1:T))] );
mind=0.3*min([min(disps2), min(gt_x(1:T)), min(gt_y(1:T))] );
%trans_scale=trans2z(T)/gt_z(T);
trans_scale=gt_z(T)/trans2z(T)

subplot(3,1,1);  plot( -trans2x(1,:)*trans_scale,'ko:'); ylabel('X-meters');hold on
subplot(3,1,1);  plot( -(trans1x(1,:)*trans_scale),'kx:'); 
%subplot(4,1,1);  plot(gt_x(1:T)*trans_scale,'bx:'); 
%axis([1 T -maxd maxd]);

subplot(3,1,2); plot(trans2y*trans_scale,'ko:'); ylabel('Y-meters');hold on
subplot(3,1,2);  plot(trans1y*trans_scale,'kx:'); 
%subplot(4,1,2);  plot(gt_y(1:T)*trans_scale,'bx:');
axis([1 T -maxd maxd]);

subplot(3,1,3); plot(trans2z*trans_scale,'ko:'); ylabel('Z-meters');hold on
subplot(3,1,3); plot(trans1z*trans_scale,'ks:'); 
%subplot(4,1,3); plot(gt_z(1:T),'bx:'); %data massage

%subplot(4,1,4); plot(trans_scale*(trans2z/max_2z)*max_1z,'ro:'); ylabel('Z-meters');hold on
%subplot(4,1,4); plot((trans_scale*trans1z/max_1z)*max_1z,'gs:');
%subplot(4,1,4); plot((trans_scale*gt_z(1:T)/max_gt_z)*max_1z,'bx:'); %data massage
%axis([1 T 0 maxd]);

xlabel('o=2cams found, x=1cam found, translations in meters vs time t frames')


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
figure(42)              %plot displacement error
hold off
clf
%%%%%%%%%%%%%%% 1 cam trans ------------------
disps1=reshape(rt1(:,4,:,1),3,[]);
trans1x=disps1(1,1:T)*kk;
trans1y=disps1(2,1:T)*kk;
trans1z=disps1(3,1:T)*kk;
max_1x=max(trans1x)*kk;
max_1y=max(trans1y)*kk;
max_1z=max(trans1z)*kk;

%%%%%%%%%%%%%%% 2 cams trans ------------------
%scale_trans_scale=flen_real(1)*pixel_size_m(1)*1000; %wrt flen of first cam

disps2=reshape(rt2(:,4,:,1),3,[]);
trans2x=disps2(1,1:T)*kk; %make it into meters
trans2y=disps2(2,1:T)*kk;
trans2z=disps2(3,1:T)*kk;

max_2x=max(trans2x);
max_2y=max(trans2y);
max_2z=max(trans2z);



max_gt_z=max(gt_z(1:T))
maxd=1.2*max([max(trans2x), max(trans1x)]);
mind=1.2*min([min(trans2x), min(trans1x)]);

 plot( (trans2x(1,1:T)*trans_scale),':ko'); ylabel('Translation X-meters');hold on
 plot( (trans1x(1,1:T)*trans_scale),':k+'); 
 plot(gt_x(1:T)*trans_scale,':kx'); 
 legend('2-cam method','1-cam method','ground truth')
 %plot(trans2z*trans_scale,':r.'); 
 
%axis([1 T -maxd maxd]);

% plot(trans2y,'ro:'); ylabel('Y-meters');hold on
% plot(trans1y,'gs:'); 
% plot(gt_y(1:T),'bx:');
% axis([1 T -maxd maxd]);

% subplot(4,1,3); plot(trans2z,'ro:'); ylabel('Z-meters');hold on
% subplot(4,1,3); plot(trans1z,'gs:'); 
% %subplot(4,1,3); plot(gt_z(1:T),'bx:'); %data massage

% subplot(4,1,4); plot((trans2z/max_2z)*max_1z,'ro:'); ylabel('Z-meters');hold on
% subplot(4,1,4); plot((trans1z/max_1z)*max_1z,'gs:');
% subplot(4,1,4); plot((gt_z(1:T)/max_gt_z)*max_1z,'bx:'); %data massage
% %axis([1 T 0 maxd]);

%xlabel('O= 2-cam method, += 1-cam method, X=ground truth : translation vs time frame')
xlabel('X-translation vs time frame')

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
figure(357)              %plot displacement error
hold off
clf
 

plot(trans2z,'ro:'); ylabel('Z-meters');hold on
plot(trans1z,'gs:'); 
plot(gt_z(1:T),'bx:'); %data massage

% plot((trans2z/max_2z)*max_1z,'ro:'); ylabel('Z');hold on
% plot((trans1z/max_1z)*max_1z,'gs:'); ylabel('Z');hold on
% plot((gt_z(1:T)/max_gt_z)*max_1z,'bx:'); %data massage
ylabel('Z in meters')
xlabel('testz ro=2cams found, gs=1cam found, bx=truth, translations in meters vs time t frames')

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
figure(358)              %plot angular error
clf
k=1; 
%cam 1 &&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
angles1=zeros(3,T);
angles1(:,1)=rpyang2(rt1(1:3,1:3,1,k));    %get first angles
for t=2:T
    %was angles(:,t)=rpyang2(rt(1:3,1:3,t,k), but has problem when ang is large
    dR=rt1(1:3,1:3,t,k)*rt1(1:3,1:3,t-1,k)';
    ang=rpyang2(dR);
    angles1(:,t)=angles1(:,t-1)+ang;   %to avoid multiple solutions in rpyang2 when ang is large
end

%cam 2 &&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
angles2=zeros(3,T);
angles2(:,1)=rpyang2(rt2(1:3,1:3,1,k));    %get first angles
for t=2:T
    %was angles(:,t)=rpyang2(rt(1:3,1:3,t,k), but has problem when ang is large
    dR=rt2(1:3,1:3,t,k)*rt2(1:3,1:3,t-1,k)';
    ang=rpyang2(dR);
    angles2(:,t)=angles2(:,t-1)+ang;   %to avoid multiple solutions in rpyang2 when ang is large
end


maxd=0.5*max([max(angles2), max(gt_an1(1:T)), max(gt_an2(1:T)), max(gt_an3(1:T))] )*180/pi;
mind=2.1*min([min(angles2), min(gt_an1(1:T)), min(gt_an2(1:T)), min(gt_an3(1:T))] )*180/pi;
% maxd=1.1*max(max(Angles));
% mind=min(min(Angles));
subplot(3,1,1);  plot(angles2(1,:)*180/pi,'ko:');ylabel('roll-angle'); hold on
subplot(3,1,1);  plot(angles1(1,:)*180/pi,'kx:');ylabel('roll-angle'); hold on
%subplot(3,1,1);  plot(gt_an1(1,:)*180/pi,'bx:');
axis([1 T mind maxd]);

subplot(3,1,2); plot(angles2(2,:)*180/pi,'ko:'); ylabel('pitch-angle');hold on
subplot(3,1,2); plot(angles1(2,:)*180/pi,'kx:'); ylabel('pitch-angle');hold on
%subplot(3,1,2); plot(gt_an2(1:T)*180/pi,'bx:'); 
axis([1 T mind maxd]);

subplot(3,1,3); plot(angles2(3,:)*180/pi,'ko:'); ylabel('yaw_angle');hold on
subplot(3,1,3); plot(angles1(3,:)*180/pi,'kx:'); ylabel('yaw-angle');hold on
%subplot(3,1,3); plot(gt_an3(1:T)*180/pi,'bx:'); 
axis([1 T mind maxd]);

xlabel('o=2cams found, x=1cam found : rotation in degrees vs time t frames')

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
figure(41)              %plot angular error
clf
k=1; 
%cam 1 &&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
angles1=zeros(3,T);
angles1(:,1)=rpyang2(rt1(1:3,1:3,1,k));    %get first angles
for t=2:T
    %was angles(:,t)=rpyang2(rt(1:3,1:3,t,k), but has problem when ang is large
    dR=rt1(1:3,1:3,t,k)*rt1(1:3,1:3,t-1,k)';
    ang=rpyang2(dR);
    angles1(:,t)=angles1(:,t-1)+ang;   %to avoid multiple solutions in rpyang2 when ang is large
end

%cam 2 &&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
angles2=zeros(3,T);
angles2(:,1)=rpyang2(rt2(1:3,1:3,1,k));    %get first angles
for t=2:T
    %was angles(:,t)=rpyang2(rt(1:3,1:3,t,k), but has problem when ang is large
    dR=rt2(1:3,1:3,t,k)*rt2(1:3,1:3,t-1,k)';
    ang=rpyang2(dR);
    angles2(:,t)=angles2(:,t-1)+ang;   %to avoid multiple solutions in rpyang2 when ang is large
end


maxd=1.1*max([max(angles2), max(gt_an1(1:T)), max(gt_an2(1:T)), max(gt_an3(1:T))] )*180/pi;
mind=1.1*min([min(angles2), min(gt_an1(1:T)), min(gt_an2(1:T)), min(gt_an3(1:T))] )*180/pi;
% maxd=1.1*max(max(Angles));
% mind=min(min(Angles));
% subplot(3,1,1);  plot(angles2(1,:)*180/pi,'ro:');ylabel('angle1'); hold on
% subplot(3,1,1);  plot(angles1(1,:)*180/pi,'gs:');ylabel('angle1'); hold on
% subplot(3,1,1);  plot(gt_an1(1,:)*180/pi,'bx:');
% axis([1 T mind maxd]);

plot(angles2(2,1:T)*180/pi,':ko'); ylabel('Pitch angle (degrees)');hold on
plot(angles1(2,1:T)*180/pi,':k+'); hold on
plot(gt_an2(1:T)*180/pi,':kx'); 
legend('2-cam method','1-cam method','ground truth')
 
axis([1 120 mind maxd]);

% subplot(3,1,3); plot(angles2(3,:)*180/pi,'ro:'); ylabel('angle3');hold on
% subplot(3,1,3); plot(angles1(3,:)*180/pi,'gs:'); ylabel('angle3');hold on
% subplot(3,1,3); plot(gt_an3(1:T)*180/pi,'bx:'); 
% axis([1 T mind maxd]);

%xlabel('O= 2-cam method, += 1-cam method, X=ground truth : rotation vs time frame')
xlabel('Rotation vs time frame')

return
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function plotxy(x,y)
figure(1)
clf
T=size(x,2);

for t=1:T
    t
    v=find(~isnan(x(:,t)));
    plot(x(v,t),y(v,t),'.');
    xmax=1.1*max(max(x(v,t)));
    xmin=1.1*min(min(x(v,t)));
    ymax=1.1*max(max(y(v,t)));
    ymin=1.1*min(min(y(v,t)));
    %axis([xmin,xmax,ymin,ymax]);
    %axis([-400,400,-400,400]);
    axis([-0.3,0.3,-0.3,0.3]);
end
return
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function plot_model(modelcell)
K=size(modelcell,1);
for k=1:K       
    figure(10*K+k)
    m=modelcell{k};
    v=find(m(4,:)==1);      %get valid model point
    scatter3(m(1,v),m(2,v),m(3,v));
    axis equal
    xlabel('x axis');
    ylabel('y axis');
    zlabel('z axis');
end
return
