function show_lowe321
% one cam method the front cam is teh reference
load lowe2xx_out
rt1=rt;

% 2 cam method the front cam is the reference
load lowe321out
rt2=rt;
[gt_x,gt_y,gt_z,gt_an1,gt_an2,gt_an3]=rb_find_gt_motion;
%plot_model(modelcell)
K=size(rt2,4);
T=size(rt2,3);
print_rt(rt1,rt2,flen_real,pixel_size_m,gt_x,gt_y,gt_z,gt_an1,gt_an2,gt_an3)
%plotxy(x,y)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%              functions                                 %%%%%%%%%%
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function plot_model(modelcell)
K=size(modelcell,1);
for k=1:K       
    figure(10*K+k)
    m=modelcell{k};
    v=find(m(4,:)==1);      %get valid model point
    scatter3(m(1,v),m(2,v),m(3,v));
    axis equal
    xlabel('x axis');
    ylabel('y axis');
    zlabel('z axis');
end
return
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%% khw %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [disps,angles]=print_rt(rt1,rt2,flen_real,pixel_size_m,gt_x,gt_y,gt_z,gt_an1,gt_an2,gt_an3)
K=size(rt2,4);
T=size(rt2,3);
figure(K*100+59)              %plot displacement error
hold off
clf
%scale_factor=flen_real(1)*pixel_size_m(1)*1000; %wrt flen of first cam
scale_factor=1;

disps1=reshape(rt1(:,4,:,1),3,[])*scale_factor;
disps2=reshape(rt2(:,4,:,1),3,[])*scale_factor;

max_x2=max(disps2(1,:));
max_y2=max(disps2(2,:));
max_z2=max(disps2(3,:));
max_gt_z=max(gt_z(1:T))
maxd=1.0*max([max(disps2), max(gt_x(1:T)), max(gt_y(1:T)), max(gt_z(1:T))] );
mind=1.0*min([min(disps2), min(gt_x(1:T)), min(gt_y(1:T)), min(gt_z(1:T))] );


max_x1=max(abs(disps1(1,:)-disps1(1,1))); % first frames is at the point of zero translation
max_y1=max(abs(disps1(2,:)-disps1(2,1)));

dz1=abs(disps1(3,:)-disps1(3,1));
max_dz1=max(dz1)


subplot(3,1,1);  plot( disps2(1,:),'ro:'); ylabel('X');hold on
subplot(3,1,1);  plot( (disps1(1,:)/max_x1)*maxd,'gs:'); 
%subplot(3,1,1);  plot( (disps1(1,:)),'gs:'); 
subplot(3,1,1);  plot(gt_x(1:T),'bx:'); 
axis([1 T -maxd maxd]);

subplot(3,1,2); plot(disps2(2,:),'ro:'); ylabel('Y');hold on
subplot(3,1,2);  plot( (disps1(2,:)/max_y1)*maxd,'gs:'); 
%subplot(3,1,2);  plot( (disps1(2,:)),'gs:'); 
subplot(3,1,2);  plot(gt_y(1:T),'bx:');
axis([1 T -maxd maxd]);

subplot(3,1,3); plot((disps2(3,:)/max_z2)*max_z2,'ro:'); ylabel('Z');hold on
subplot(3,1,2);  plot( (disps1(3,:)/max_y1)*maxd,'gs:'); 
%subplot(3,1,3); plot( (dz1/max_dz1)*max_z2,'gs:'); 
subplot(3,1,3); plot((gt_z(1:T)/max_gt_z)*max_z2,'bx:'); %data massage
axis([1 T 0 maxd]);

xlabel('ro=2cams found, gs=1cam found, bx=truth, translations in mm vs time t frames')

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
figure(K*100+58)              %plot angular error
clf
k=1; 
angles=zeros(3,T);
angles(:,1)=rpyang2(rt2(1:3,1:3,1,k));    %get first angles
for t=2:T
    %was angles(:,t)=rpyang2(rt(1:3,1:3,t,k), but has problem when ang is large
    dR=rt2(1:3,1:3,t,k)*rt2(1:3,1:3,t-1,k)';
    ang=rpyang2(dR);
    angles(:,t)=angles(:,t-1)+ang;   %to avoid multiple solutions in rpyang2 when ang is large
end

%convert one cam rt into an (angles)
for i=1:T
  an_cam1(:,i)=rpyAng(rt1(:,1:3,i));
end


maxd=1.1*max([max(angles), max(gt_an1(1:T)), max(gt_an2(1:T)), max(gt_an3(1:T))] )*180/pi;
mind=1.1*min([min(angles), min(gt_an1(1:T)), min(gt_an2(1:T)), min(gt_an3(1:T))] )*180/pi;
% maxd=1.1*max(max(Angles));
% mind=min(min(Angles));
subplot(3,1,1);  plot(angles(1,:)*180/pi,'ro:');ylabel('angle1'); hold on
subplot(3,1,1);  plot(an_cam1(1,:)*180/pi,'gs:');
subplot(3,1,1);  plot(gt_an1(1,:)*180/pi,'bx:');
axis([1 T mind maxd]);

subplot(3,1,2); plot(angles(2,:)*180/pi,'ro:'); ylabel('angle2');hold on
subplot(3,1,2);  plot(an_cam1(2,:)*180/pi,'gs:');
subplot(3,1,2); plot(-gt_an2(1:T)*180/pi,'bx:'); 
axis([1 T mind maxd]);

subplot(3,1,3); plot(angles(3,:)*180/pi,'ro:'); ylabel('angle3');hold on
subplot(3,1,3);  plot(an_cam1(3,:)*180/pi,'gs:');
subplot(3,1,3); plot(gt_an3(1:T)*180/pi,'bx:'); 
axis([1 T mind maxd]);

xlabel('ro=2cams found, gs=1cam found, bx=truth : rotation in degrees vs time t frames')

return
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function plotxy(x,y)
figure(1)
clf
T=size(x,2);

for t=1:T
    t
    v=find(~isnan(x(:,t)));
    plot(x(v,t),y(v,t),'.');
    xmax=1.1*max(max(x(v,t)));
    xmin=1.1*min(min(x(v,t)));
    ymax=1.1*max(max(y(v,t)));
    ymin=1.1*min(min(y(v,t)));
    %axis([xmin,xmax,ymin,ymax]);
    %axis([-400,400,-400,400]);
    axis([-0.3,0.3,-0.3,0.3]);
end
return

